
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz](
		[idLinea] [varchar](50) NULL,
		[idOperacion] [varchar](200) NULL,
		[codigo] bigint NULL,
		[idCalificacion] [bigint] NULL,
		[empresa] [bigint] NULL
	) ON [PRIMARY]

go
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_Area]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz_Area](
		[idArea] [varchar](50) NOT NULL,
		[nombre] [varchar](250) NULL,
		[empresa] [bigint] NULL,
	 CONSTRAINT [PK_capaMatriz_Area] PRIMARY KEY CLUSTERED 
	(
		[idArea] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

go
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_Calificaciones]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz_Calificaciones](
		[idCalificacion] [bigint] IDENTITY(1,1) NOT NULL,
		[letra] [varchar](1) NULL,
		[valor] [decimal](18, 0) NULL,
		[empresa] [bigint] NULL,
	) ON [PRIMARY]

GO
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_Linea]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [dbo].[capaMatriz_Linea](
		[idLinea] [varchar](25) NOT NULL,
		[nombre] [varchar](250) NULL,
		[empresa] [bigint] NULL,
	 CONSTRAINT [PK_capaMatriz_Linea] PRIMARY KEY CLUSTERED 
	(
		[idLinea] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

GO
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_LineaArea]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz_LineaArea](
		[idArea] [varchar](50) NULL,
		[idLinea] [varchar](50) NULL,
		[empresa] [bigint] NULL
	) ON [PRIMARY]

GO
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_OperacionLinea]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz_OperacionLinea](
		[idOperacion] [varchar](200) NULL,
		[idLinea] [varchar](50) NULL,
		[idArea] [varchar](25) NULL,
		[empresa] [bigint] NULL
	) ON [PRIMARY]

GO
/*----------------------------------------------------------------------*/
 if not exists (select * from dbo.sysobjects  
                 where id = object_id(N'[dbo].[capaMatriz_Operacion]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[capaMatriz_Operacion](
		[idOperacion] [varchar](200) NOT NULL,
		[nombre] [varchar](250) NULL,
		[secuencia] [int] NULL,
		[polivalencia] [int] NULL,
		[empresa] [bigint] NULL,
	 CONSTRAINT [PK_grammerOperacion] PRIMARY KEY CLUSTERED 
	(
		[idOperacion] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
GO

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.ID = T.ID 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capaMatriz' 
                 and c.name='fecha')
  ALTER TABLE  capaMatriz ADD fecha datetime null
go

update capaMatriz set fecha='19000101' where fecha is null

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capaMatriz_Linea' 
                 and c.name='orden')
  ALTER TABLE capaMatriz_Linea ADD orden bigint NULL
go

if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capaMatriz_Operacion' 
                 and c.name='orden')
  ALTER TABLE capaMatriz_Operacion ADD orden bigint NULL
go

update capaMatriz_Operacion set orden=0 where orden is null
go
update capaMatriz_Linea set orden=0 where orden is null
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaInsertaPieDePaginaReporte')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaInsertaPieDePaginaReporte
GO

CREATE PROCEDURE dbo.CapaInsertaPieDePaginaReporte
	(@lugar as varchar(50),
	 @nombre as varchar(500))
AS 
	BEGIN	
	
	declare @empresa bigint
	
	DECLARE empresacursor CURSOR  
    FOR SELECT empresa FROM empresas
	OPEN empresacursor  
	FETCH NEXT FROM empresacursor into @empresa
	
	WHILE @@FETCH_STATUS = 0  
	BEGIN 
	
		if not exists (Select nombre from Capa_piedepagina where nombre=@nombre and empresa=@empresa) 	
		INSERT INTO Capa_piedepagina
			   (empresa
			   ,nombre
			   ,Reporte
			   ,ubicacion
			   ,lado
			   ,texto
			   ,ladoSup
			   ,TextoSup)
		 VALUES
			   (@empresa
			   ,@nombre
			   ,@nombre
			   ,@lugar
			   ,''
			   ,''
			   ,''
			   ,'')
		FETCH NEXT FROM empresacursor INTO @empresa    
	END   
	CLOSE empresacursor
	deallocate empresacursor

	end

go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaNombreEmpleado')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaNombreEmpleado
GO

CREATE PROCEDURE dbo.CapaMatrizCargaNombreEmpleado
	(@companyID bigint,
	 @codigo bigint) 
AS 
	BEGIN	
		SELECT  rtrim(isnull(nombre,'')) + ' ' + rtrim(isnull(ap_paterno,'')) + ' ' + rtrim(isnull(ap_materno,''))
		FROM empleados
		WHERE empresa = @companyID
		and codigo=@codigo
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaNombreLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaNombreLinea
GO

CREATE PROCEDURE dbo.CapaMatrizCargaNombreLinea
	(@companyID bigint,
	 @clave varchar(25)) 
AS 
	BEGIN	
		SELECT nombre
		FROM capaMatriz_Linea
		WHERE empresa = @companyID
		and idlinea=@clave
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaLineas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaLineas
GO

CREATE PROCEDURE dbo.CapaMatrizCargaLineas
	(@companyID bigint) 
AS 
	BEGIN	
		SELECT idLinea
			   ,nombre
			   ,orden
		FROM capaMatriz_Linea
		WHERE empresa = @companyID
		order by orden
	end
go  


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaLinea
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaLinea
	(	@idLinea varchar(25),
		@companyId bigint		) 
AS 
	BEGIN	
	
	delete from capaMatriz_Linea
	where idLinea=@idLinea
	and empresa=@companyId
	
	END
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaLinea
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaLinea
	(	@idLinea varchar(25),
		@clave varchar(25),
		@nombre varchar(250),
		@empresa bigint,
		@orden bigint	) 
AS 
	BEGIN	
	
	if @idLinea=''
		begin
		
			INSERT INTO capaMatriz_Linea
				   (idLinea
				   ,nombre
				   ,empresa
				   ,orden)
			 VALUES
				   (@clave
				   ,@nombre
				   ,@empresa
				   ,@orden)
		end
	else
		begin
			
			 UPDATE capaMatriz_Linea
			   SET nombre = @nombre,				  	  
			       idLinea = @clave,
			       orden=@orden
			 WHERE empresa=@empresa
				and idLinea=@idLinea
		end				   

	end
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaNombreCalificacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaNombreCalificacion
GO

CREATE PROCEDURE dbo.CapaMatrizCargaNombreCalificacion
	(@companyID bigint,
	 @clave varchar(25)) 
AS 
	BEGIN	
		SELECT valor
		FROM capaMatriz_calificaciones
		WHERE empresa = @companyID
		and letra=@clave
	end	
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaCalificacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaCalificacion
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaCalificacion
	(	@idcalificacion bigint,
		@letra varchar(1),
		@valor decimal(18,0),
		@companyID bigint) 
AS 
	BEGIN	
	
	if @idcalificacion=0
		begin
		
			INSERT INTO capaMatriz_Calificaciones
				   (letra
				   ,valor
				   ,empresa)
			 VALUES
				   (@letra
				   ,@valor
				   ,@companyID)
		end
	else
		begin
			UPDATE capaMatriz_Calificaciones
			   SET letra = @letra
				  ,valor = @valor				  
			 WHERE empresa=@companyID
				and idCalificacion=@idcalificacion
		end				   

	end
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaCalificacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaCalificacion
GO

CREATE PROCEDURE dbo.CapaMatrizCargaCalificacion
	(@companyID bigint) 
AS 
	BEGIN	
		SELECT idCalificacion
				,letra
				,valor
		FROM capaMatriz_Calificaciones
		WHERE empresa = @companyID
	end
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaCalificacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaCalificacion
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaCalificacion
	(	@idcalificacion bigint,
		@companyId bigint		) 
AS 
	BEGIN	
	
	delete from capaMatriz_Calificaciones
	where idCalificacion=@idcalificacion
	and empresa=@companyId
	
	END
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaArea
GO

CREATE PROCEDURE dbo.CapaMatrizCargaArea
	(@companyID bigint) 
AS 
	BEGIN	
		SELECT idArea, nombre
		FROM capaMatriz_Area
		WHERE empresa = @companyID
	end
go  


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaArea
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaArea
	(@idArea varchar(50),
	 @clave varchar(50),
	 @nombre varchar(250), 
	 @companyID bigint) 
AS 
	begin
		if @idArea=''
			begin		
				INSERT INTO capaMatriz_Area
					   (idArea
					   ,nombre
					   ,empresa)
				 VALUES
					   (@clave
					   ,@nombre
					   ,@companyID)
			end
		else
			begin
				UPDATE capaMatriz_Area
				   SET idArea= @clave
					  ,nombre = @nombre				  
				 WHERE empresa=@companyID
					and idArea=@clave
			end				   

	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaLineasPorArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaLineasPorArea
GO

CREATE PROCEDURE dbo.CapaMatrizCargaLineasPorArea
	( @idArea varchar(50),@companyID bigint) 
AS 
	BEGIN	
		SELECT l.idLinea,l.nombre
		FROM capaMatriz_Area a, capaMatriz_Linea l, capaMatriz_LineaArea la
		WHERE a.empresa = @companyID
		and a.empresa= l.empresa
		and a.empresa=la.empresa
		and a.idArea=la.idarea
		and l.idLinea=la.idLinea
		and a.idArea=@idArea		
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaArea
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaArea
	(	@idArea varchar(25),
		@companyId bigint		) 
AS 
	BEGIN	
	
	delete from capaMatriz_Area
	where idArea=@idArea
	and empresa=@companyId
	
	END
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaLineaArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaLineaArea
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaLineaArea
	(	@idArea varchar(25),
		@idLinea varchar(25),
		@companyId bigint		) 
AS 
	BEGIN	
	
		delete from capaMatriz_LineaArea
		where idArea=@idArea
		and idLinea=@idLinea
		and empresa=@companyId
	
	END
go



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaLineaPorArea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaLineaPorArea
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaLineaPorArea
	(@idArea varchar(50),
	 @idLinea varchar(25),
	 @companyID bigint) 
AS 
	begin		
		INSERT INTO capaMatriz_LineaArea
			   (idArea
			   ,idlinea
			   ,empresa)
		 VALUES
			   (@idArea
			   ,@idlinea
			   ,@companyID)
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaNombreOperacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaNombreOperacion
GO

CREATE PROCEDURE dbo.CapaMatrizCargaNombreOperacion
	(@companyID bigint,
	 @clave varchar(25)) 
AS 
	BEGIN	
		SELECT nombre
		FROM capaMatriz_Operacion
		WHERE empresa = @companyID
		and idOperacion=@clave
	end	
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaOperacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaOperacion
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaOperacion
	(	@idOperacion varchar(25),
		@companyId bigint		) 
AS 
	BEGIN	
	
	delete from capaMatriz_operacion
	where idOperacion=@idOperacion
	and empresa=@companyId
	
	END
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaOperacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaOperacion
GO

CREATE PROCEDURE dbo.CapaMatrizCargaOperacion
	(@companyID bigint) 
AS 
	BEGIN	
		SELECT idoperacion	
			   ,nombre
			   ,secuencia
			   ,polivalencia
			   ,orden as orden
		FROM capaMatriz_Operacion
		WHERE empresa = @companyID
		order by orden
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaOperacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaOperacion
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaOperacion
	(   @idOperacion varchar(25),
		@clave varchar(250),
		@nombre varchar(250),
		@secuencia integer,
		@polivalencia integer,	
		@companyId bigint,
		@orden bigint  ) 
AS 
	begin
		if @idOperacion='0'
			begin		
				INSERT INTO capaMatriz_Operacion
					   (idOperacion
					   ,nombre
					   ,secuencia
					   ,polivalencia
					   ,empresa
					   ,orden)
				 VALUES
					   (@clave
					   ,@nombre
					   ,@secuencia
					   ,@polivalencia
					   ,@companyID
					   ,@orden)
			end
		else
			begin
				UPDATE capaMatriz_Operacion
	  		     SET nombre = @nombre,			  
	  				 secuencia=@secuencia,
	  				 polivalencia=@polivalencia,
	  				 orden=@orden
				 WHERE empresa=@companyID
					and idOperacion=@clave
			end				   

	end
go 

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaCaptura')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaCaptura
GO

CREATE PROCEDURE dbo.CapaMatrizCargaCaptura
	(@empresa bigint,
	 @area varchar(25),
	 @linea varchar(50),
  	 @orden int) 
AS 
	BEGIN	
		SELECT	e.codigo, 
				rtrim(isnull(e.nombre,'')) + ' ' + rtrim(isnull(e.ap_paterno,'')) + ' ' + rtrim(isnull(e.ap_materno,'')) as nombreEmpleado,
				isnull(a.idarea,'') as idArea,
				isnull(a.nombre,'') as nombreArea,
				isnull(l.idLinea,'') as idlinea, 
				isnull(l.nombre,'') as nombrelinea, 
				isnull(o.idOperacion,'') as idoperacion, 
				isnull(o.nombre,'') as nombreOperacion, 				
				isnull(c.idCalificacion,0) as idCalificacion, 				
				isnull(c.valor,0) as valor, 
				isnull(c.letra,0) as letra,
				convert(varchar(10),m.fecha,103)
        FROM capaMatriz m 
			left join empleados e on m.codigo=e.codigo and m.empresa=e.empresa 
			left join capaMatriz_Linea l on l.idLinea=m.idLinea and m.empresa=l.empresa
			left join capaMatriz_LineaArea la on la.idlinea=l.idlinea and m.empresa=la.empresa
			left join capaMatriz_Calificaciones c on c.idCalificacion=m.idCalificacion and m.empresa=l.empresa
			left join capaMatriz_Operacion o on o.idOperacion=m.idOperacion and m.empresa=o.empresa
			left join capaMatriz_Area a on a.empresa=la.empresa and a.idarea=la.idarea 
		WHERE e.empresa = @empresa
		and IIF(@area='','',@Area)=IIF(@area='','',a.idArea)
		and IIF(@linea='','',@linea)=IIF(@linea='','',l.idlinea)
		order by IIF(@orden=1,m.fecha,e.codigo) desc
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaCaptura')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaCaptura
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaCaptura
	(@empresa bigint,
	@codigo bigint,
	@linea varchar(25),
	@operacion varchar(200),
	@calificacion bigint,
	@fecha datetime) 
AS 
	BEGIN	
		Delete FROM capaMatriz 		
		WHERE empresa = @empresa
		and codigo	  = @codigo
		and idLinea   = @linea
		and idOperacion = @operacion
		and idCalificacion  =@calificacion
		and fecha  =@fecha

	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaCaptura')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaCaptura
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaCaptura
	(@linea varchar(50),	
	@operacion varchar(200),
	@codigo bigint,
	@calificacion varchar(1),
	@companyID bigint,
	@fecha datetime) 
AS 
	BEGIN	
		declare @idCalificacion bigint
	
		select @idCalificacion=idcalificacion
		from capamatriz_calificaciones
		where letra=@calificacion 
	
		INSERT INTO capaMatriz
			   (idLinea
			   ,idOperacion
			   ,codigo
			   ,idCalificacion
			   ,empresa
			   ,fecha)
		 VALUES
			   (@linea
			   ,@operacion
			   ,@codigo
			   ,@idcalificacion
			   ,@companyID
			   ,@fecha)
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizModificaCaptura')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizModificaCaptura
GO

CREATE PROCEDURE dbo.CapaMatrizModificaCaptura
	(@companyID_old bigint,
	@codigo_old bigint,
	@operacion_old varchar(200),
	@linea_old varchar(25),
	@calificacion_old varchar(1),
	@companyID bigint,
	@codigo bigint,
	@operacion varchar(25),
	@linea varchar(25),
	@calificacion varchar(1)) 
AS 
	BEGIN	
		declare @idCalificacion bigint
		declare @idCalificacion_old bigint
	
		select @idCalificacion=isnull(idcalificacion,0)
		from capamatriz_calificaciones
		where letra=@calificacion 
		
		select @idCalificacion_old=isnull(idcalificacion,0)
		from capamatriz_calificaciones
		where letra=@idCalificacion_old 
	
	  UPDATE capaMatriz 
		   SET idLinea = @linea 
			  ,idOperacion = @operacion
			  ,codigo =  @codigo 
			  ,idCalificacion =  @idCalificacion
			  ,empresa =  @companyID	
		 WHERE  idLinea= @linea_old
			  and idOperacion = @operacion_old
			  and codigo =  @codigo_old
			  and idCalificacion =  @idCalificacion_old
			  and empresa =  @companyID_old	
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReporteHabilidadesCruzado')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReporteHabilidadesCruzado
GO

CREATE PROCEDURE dbo.CapaMatrizReporteHabilidadesCruzado
	(@companyID bigint,
	 @codigo bigint,
	 @linea varchar(25),
	 @area varchar(25),
	 @fechaDe datetime,
	 @fechaA datetime) 
AS 

	DECLARE @cSelectClause udtStringSize1024
	DECLARE @cFromClause udtStringSize1024
	DECLARE @cWhereClause udtStringSize1024
	DECLARE @groupByClause udtStringSize1024
	DECLARE @orderByClause udtStringSize1024
	DECLARE @TotalOperaciones bigint
	
	select @TotalOperaciones=COUNT(idOperacion)
	from capaMatriz_Operacion
	where empresa=@companyId
	
     SET @cSelectClause = ' select e.codigo as Codigo, 
				rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')) as Nombre,
				isnull(m.idoperacion,''Avance'') as operacion,
				isnull(o.nombre,'''') as NombreOperacion,
				isnull(valor,0) as valor,
				isnull(l.idlinea,'''') as idLinea,
				isnull(l.nombre,'''') as nombreLinea,
				isnull(l.orden,0) as ordenlinea,
				isnull(a.idArea,'''') as area,
				isnull(a.nombre,'''') as nombreArea,
				isnull(letra,'''') as letra,
				CONVERT(varchar(10),e.fchalta,103) as fechaingreso,
				case tiponom
					when 1 then ''Semanal''
					when 2 then ''Decenal''
					when 3 then ''Catorcenal''
					when 4 then ''Quincenal''
					when 5 then ''Mensual''
					when 6 then ''Especial''
				end as tiponomina,
				cf.logo,
				o.orden'
			
	SET @cFromClause = ' FROM empleados e 
				 left join capa_ArchivosFirmas cf on cf.empresa=e.empresa
				 left join capaMatriz m on e.empresa=m.empresa and e.codigo=m.codigo
				 left join llaves ll on ll.empresa=e.empresa and ll.codigo=e.codigo
				 left join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa
				 left join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
				 left join capaMatriz_lineaArea la on m.idLinea=la.idLinea and m.empresa=la.empresa
				 left join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa				 
				 left join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa 
				 '
	
	set @cWhereClause=' WHERE e.empresa = ' + convert(varchar(10),@companyID) 
					+ '	and m.fecha between ''' + convert(varchar(10),@fechaDe,112) + ''' and ''' +  convert(varchar(10),@fechaA,112) + ''''
	
	if @codigo<>0
		begin
			set @cWhereClause=@cWhereClause + ' and e.codigo = ' + convert(varchar(10),@codigo) 
		end
		
	if @linea<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and l.idLinea = ''' + @linea + ''''
		end
		
	if @area<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and a.idArea = ''' + @area + ''''
		end		
		
	set @groupByClause= ' group by e.codigo, 
				rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')),
				m.idoperacion,
				o.nombre,
				valor ,
				l.idlinea,
				l.nombre,
				l.orden,
				a.idArea,
				a.nombre,
				letra,
				e.fchalta,
				tiponom,
				cf.logo,
				o.orden'			

	set @orderByClause= ' ORDER BY E.CODIGO, L.ORDEN, o.ORDEN'
						
	exec (@cSelectClause + @cFromClause + @cWhereClause + @groupByClause + @orderByClause)
		
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReporteHabilidadesCruzadoAPSI')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReporteHabilidadesCruzadoAPSI
GO

CREATE PROCEDURE dbo.CapaMatrizReporteHabilidadesCruzadoAPSI
	(@companyID bigint,
	 @codigo bigint,
	 @linea varchar(25),
	 @area varchar(25),
	 @fechaDe datetime,
	 @fechaA datetime) 
AS 

	DECLARE @cSelectClause udtStringSize1024
	DECLARE @cFromClause udtStringSize1024
	DECLARE @cWhereClause udtStringSize1024
	DECLARE @groupByClause udtStringSize1024
	DECLARE @groupByClause2 udtStringSize1024
	DECLARE @orderByClause udtStringSize1024
	DECLARE @TotalOperaciones bigint
	
	select @TotalOperaciones=COUNT(idOperacion)*100
	from capaMatriz_Operacion
	where empresa=@companyId
	
    SET @cSelectClause = ' select 
				e.codigo as Codigo, 
				rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')) as Nombre,				
				isnull(a.idArea,'''') as area,
				isnull(a.idArea,'''') as area + '' '' + isnull(a.nombre,'''') as nombreArea,
				isnull(m.idoperacion,''Sin Op.'') as operacion + '' '' + isnull(o.nombre,'''') as NombreOperacion,
				isnull(o.nombre,'''') as NombreOperacion,
				isnull(sum(valor),0)  as valor,
				''100'' as Total, 
				isnull(cast(sum(valor) * 100 / ' + convert(varchar(10),@TotalOperaciones,106) + ' as int ),0) as Avance,
				isnull(100- cast(sum(valor) * 100 / ' + convert(varchar(10),@TotalOperaciones,106) + ' as int ),100) as Falta'
			
	SET @cFromClause = ' FROM empleados e 
				 left join capaMatriz m on e.empresa=m.empresa and e.codigo=m.codigo
				 full outer join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa
				 left join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
				 left join capaMatriz_lineaArea la on m.idLinea=la.idLinea and m.empresa=la.empresa
				 left join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa
				 full outer join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa 
				 '
	
	set @cWhereClause=	' WHERE e.empresa = ' + convert(varchar(10),@companyID)  + 
						' m.fecha between ' + convert(varchar(10),@fechaDe) + ' and '  + convert(varchar(10),@fechaA)
					 
	
	if @codigo<>0
		begin
			set @cWhereClause=@cWhereClause + ' and e.codigo = ' + convert(varchar(10),@codigo) 
		end
		
	if @linea<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and l.idLinea = ''' + @linea + ''''
		end
		
	if @area<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and a.idArea = ''' + @area + ''''
		end		
		
	set @groupByClause= ' group by GROUPING SETS (	
						  a.idArea,
						  a.nombre ,
						  m.idoperacion,
						  o.nombre,
						  (e.codigo, 
						  rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,''''))
						  ))
						'	
						
	set @groupByClause2= ' group by GROUPING SETS (	
						  a.idArea,
						  a.nombre ,
						  (m.idoperacion,
						  o.nombre,
						  e.codigo, 
						  rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,''''))
						  ))
						'									

	set @orderByClause= ' HAVING e.codigo is not null '
						
	
	exec ('(' + @cSelectClause + @cFromClause + @cWhereClause + @groupByClause + @orderByClause +
	 ') union ('+
	 @cSelectClause + @cFromClause + @cWhereClause + @groupByClause2 + @orderByClause + ')'
	 )
		
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReportePolivalencia')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReportePolivalencia
GO

CREATE PROCEDURE dbo.CapaMatrizReportePolivalencia
	(@companyID bigint) 
AS 
	
   select e.codigo, 
		rtrim(isnull(e.nombre,'')) + ' ' + rtrim(isnull(e.ap_paterno,'')) + ' ' + rtrim(isnull(e.ap_materno,'')) as nombreEmpleado,
		isnull(m.idoperacion,'0') as operacion,
		isnull(o.nombre,'') as NombreOperacion,
		o.polivalencia,
		o.secuencia,
		isnull(valor,0) as valor
	FROM empleados e 
	full outer join capaMatriz m on e.empresa=m.empresa and e.codigo=m.codigo
	full outer join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa
	full outer join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa
	WHERE e.empresa =  convert(varchar(10),@companyID) 
		
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizObtenEmpleados')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizObtenEmpleados
GO

CREATE PROCEDURE dbo.CapaMatrizObtenEmpleados
	(@companyID bigint) 
AS 
	BEGIN	
		SELECT  codigo, rtrim(isnull(nombre,'')) + ' ' + rtrim(isnull(ap_paterno,'')) + ' ' + rtrim(isnull(ap_materno,''))
		FROM empleados
		WHERE empresa = @companyID
	end
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGrupos')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGrupos
GO

CREATE PROCEDURE dbo.CapaMatrizGrupos
	(@companyID bigint,
	 @linea varchar(max),
	 @area varchar(max),
	 @operacion varchar(200),
	 @fechaDe datetime,
	 @fechaA datetime) 
AS 

	DECLARE @cSelectClause udtStringSize4096
	DECLARE @cFromClause udtStringSize4096
	DECLARE @cWhereClause udtStringSize4096
	declare @orderbyClause udtStringSize1024
	declare @cGroupByClause udtStringSize4096
	
    SET @cSelectClause = ' select sum(c.valor) as valor,
							e.codigo, 
							rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')) as nombreEmpleado,
							isnull(m.idoperacion,''0'') as operacion,
							isnull(o.nombre,'''') as NombreOperacion,
							isnull(l.idlinea,'''') as idlinea,
							isnull(l.nombre,'''') as nombrelinea,
							isnull(a.idArea,'''') as idarea,
							isnull(a.nombre,'''') as nombreArea,
							t.actividad,
							m.fecha'
			
	SET @cFromClause = ' FROM capaMatriz m 
						 inner join empleados e on e.empresa=m.empresa and e.codigo=m.codigo
						 inner join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa						 											 
						 inner join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
						 inner join capaMatriz_lineaArea la on l.idLinea=la.idLinea and l.empresa=la.empresa						
						 inner join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa  							 
						 inner join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa
						 inner join llaves ll on ll.codigo=e.codigo and ll.empresa=m.empresa
						 inner join tabulador t on t.ocupacion=ll.ocupacion and t.empresa=e.empresa'
	
	set @cWhereClause=' WHERE e.empresa = ' + convert(varchar(10),@companyID) 
	set @cWhereClause= @cWhereClause + ' and m.fecha between ''' + CONVERT(varchar(10),@fechaDe,112) +''' and ''' + CONVERT(varchar(10),@fechaA,112) + ''' '
		
	if @linea<>'()'
		begin
			set @cWhereClause=@cWhereClause +' and la.idLinea in ' + @linea
		end
		
	if @area<>'()'
		begin
			set @cWhereClause=@cWhereClause +' and la.idArea in ' + @area 
		end	
		
	if @operacion<>'()'
		begin
			set @cWhereClause=@cWhereClause +' and m.idOperacion in ' + @operacion 
		end	
		
    SET @cGroupByClause = ' group by isnull(a.idArea,''''),
							isnull(a.nombre,'''') ,
							isnull(l.idlinea,''''),
							isnull(l.nombre,'''') ,
							isnull(m.idoperacion,''0''),
							isnull(o.nombre,'''') ,
							e.codigo, 
							rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')),														
							c.valor,
							t.actividad,
							m.fecha'
						
	set @orderbyClause = ' order by a.idArea,la.idLinea,m.idOperacion, e.codigo'
	
	exec  (@cSelectClause + @cFromClause + @cWhereClause + @cGroupByClause  )
		
go  



IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaDatosDeBajas')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaDatosDeBajas
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaDatosDeBajas
	(@companyID bigint) 
AS 

	Delete 
	From capaMatriz 
	Where codigo in 
	(Select codigo
	from empleados 
	where empresa=@companyID
	and (ultmov='B'))
	and empresa=@companyID
	
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaBusquedaEmpleados')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaBusquedaEmpleados
GO

CREATE PROCEDURE dbo.CapaBusquedaEmpleados
	(@companyID bigint,
	@estatusEmpleado as Char(1)) 
AS 

	if @estatusEmpleado='S'
		begin
			select convert(varchar(10),e.codigo) as codigo, 
					e.nombre, 
					e.ap_paterno, 
					e.ap_materno,
					convert(varchar(10),m.empresa) as empresa, 
					m.referencia,  
					case iif(e.activo='S' or e.ultmov<>'B','S','N')
					 when 'S' then 'Activo' else 'Baja'
					 end as estatus
			from empleados e, empresas m
			where e.empresa=m.empresa 
			and e.empresa=@companyID
			and (e.activo='S' or e.ultmov<>'B')
		end


	if @estatusEmpleado='T'
		begin
			select convert(varchar(10),e.codigo) as codigo, 
					e.nombre, 
					e.ap_paterno, 
					e.ap_materno,
					convert(varchar(10),m.empresa) as empresa, 
					m.referencia,  
					case iif(e.activo='S' or e.ultmov<>'B','S','N')
					 when 'S' then 'Activo' else 'Baja'
					 end as estatus
			from empleados e, empresas m
			where e.empresa=m.empresa 
			and e.empresa=@companyID
		end
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.capaMatrizTrabajador')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.capaMatrizTrabajador
GO

CREATE PROCEDURE dbo.capaMatrizTrabajador
	(@companyID bigint,
	@codigo bigint) 
AS 
	select e.codigo, 
	rtrim(isnull(e.nombre,'')) + ' ' + rtrim(isnull(e.ap_paterno,'')) + ' ' + rtrim(isnull(e.ap_materno,'')) as nombreEmpleado,
	isnull(m.idoperacion,'0') as operacion,
	isnull(o.nombre,'')  as NombreOperacion,
	isnull(c.valor,0)    as valor ,
	isnull(l.idlinea,'') as idlinea,
	isnull(l.nombre,'')  as nombrelinea,
	isnull(a.idArea,'')  as idarea,
	isnull(a.nombre,'')  as nombreArea,
	t.actividad,
	isnull(datosemps.foto,'') as foto,
	c.letra	,
	m.fecha
	FROM capaMatriz m 
	 inner join empleados e on e.empresa=m.empresa and e.codigo=m.codigo
	 inner join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa						 											 
	 inner join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
	 inner join capaMatriz_lineaArea la on l.idLinea=la.idLinea and l.empresa=la.empresa						
	 inner join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa  							 
	 inner join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa
	 inner join llaves ll on ll.codigo=e.codigo and ll.empresa=m.empresa
	 inner join tabulador t on t.ocupacion=ll.ocupacion and t.empresa=e.empresa	
	 inner join datosemps on ll.empresa=datosemps.empresa and ll.codigo=datosemps.codigo
	WHERE e.empresa = @companyID
	and e.codigo=@codigo
	order by e.codigo, a.idArea, l.idLinea, m.idOperacion
	
go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.capaObtenPieDePaginaMAtriz')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.capaObtenPieDePaginaMAtriz
GO

CREATE PROCEDURE dbo.capaObtenPieDePaginaMAtriz
	(@companyID bigint) 
AS 

	SELECT lado,texto,ladosup,textosup
	FROM capa_piedepagina
	WHERE nombre='Matriz de Habilidades'
	and empresa=@companyID
	
go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReporteHabilidadesGrafico')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReporteHabilidadesGrafico
GO

CREATE PROCEDURE dbo.CapaMatrizReporteHabilidadesGrafico
	(@companyID bigint,
	 @codigo bigint,
	 @linea varchar(25),
	 @area varchar(25),
	 @fechaDe datetime,
	 @fechaA datetime) 
AS 
BEGIN
	DECLARE @cSelectClause udtStringSize1024
	DECLARE @cFromClause udtStringSize1024
	DECLARE @cWhereClause udtStringSize1024
	DECLARE @groupByClause udtStringSize1024
	DECLARE @orderByClause udtStringSize1024
	DECLARE @TotalOperaciones bigint
	
	select @TotalOperaciones=COUNT(idOperacion)
	from capaMatriz_Operacion
	where empresa=@companyId

	SET @cSelectClause = '  select e.empresa,
							e.codigo as Codigo, 							
							rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')) as Nombre,
							e.fchalta as fechaingreso,
							case tiponom
								when 1 then ''Semanal''
								when 2 then ''Decenal''
								when 3 then ''Catorcenal''
								when 4 then ''Quincenal''
								when 5 then ''Mensual''
								when 6 then ''Especial''
							end as tiponomina,
							isnull(m.idoperacion,''Avance'') as operacion,
							isnull(o.nombre,'''') as NombreOperacion,
							isnull(l.idlinea,'''') as idLinea,
							isnull(l.nombre,'''') as nombreLinea,
							isnull(a.idArea,'''') as area,
							isnull(a.nombre,'''') as nombreArea,					
							cf.logo, 
							isnull(valor,0) as valor
							'
			
	SET @cFromClause = ' FROM capaMatriz m			 
				 inner join empleados e  on e.empresa=m.empresa and e.codigo=m.codigo
				 inner join llaves ll on ll.empresa=e.empresa and ll.codigo=e.codigo
				 inner join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa
				 inner join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
				 inner join capaMatriz_lineaArea la on l.idLinea=la.idLinea and l.empresa=la.empresa
				 inner join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa				 
				 inner join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa 
				 inner join capa_ArchivosFirmas cf on cf.empresa=e.empresa
				 '
	
	set @cWhereClause=' WHERE e.empresa = ' + convert(varchar(10),@companyID) 
					+ '	and m.fecha between ''' + convert(varchar(10),@fechaDe,112) + ''' and ''' +  convert(varchar(10),@fechaA,112) + ' 11:59:59'''
	
	if @codigo<>0
		begin
			set @cWhereClause=@cWhereClause + ' and e.codigo = ' + convert(varchar(10),@codigo) 
		end
		
	if @linea<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and l.idLinea = ''' + @linea + ''''
		end
		
	if @area<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and a.idArea = ''' + @area + ''''
		end		
		
	/*set @groupByClause= ' group by e.empresa, e.codigo, 
							rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')),
							m.idoperacion,
							o.nombre,
							l.idlinea,
							l.nombre,
							a.idArea,
							a.nombre,
							e.fchalta,
							tiponom,
							cf.logo '	*/
						
	exec (@cSelectClause + @cFromClause + @cWhereClause)-- + @groupByClause )


END		
go  

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReportePivot')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReportePivot
GO
CREATE PROCEDURE dbo.CapaMatrizReportePivot(
    @companyID bigint,
	@codigo bigint,
	@linea varchar(25),
	@area varchar(25),
	@fechaDe datetime,
	@fechaA datetime)
AS
BEGIN
 
    DECLARE @sql nvarchar(MAX);
    declare @ListToPivot nvarchar(max)

	DECLARE @cWhereClause nvarchar(max)

	set @cWhereClause=' WHERE e.empresa = ' + convert(varchar(10),@companyID) 
					+ '	and m.fecha between ''' + convert(varchar(10),@fechaDe,112) + ''' and ''' +  convert(varchar(10),@fechaA,112) + ' 11:59:59'''
	
	if @codigo<>0
		begin
			set @cWhereClause=@cWhereClause + ' and e.codigo = ' + convert(varchar(10),@codigo) 
		end
		
	if @linea<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and l.idLinea = ''' + @linea + ''''
		end
		
	if @area<>'0'
		begin
			set @cWhereClause=@cWhereClause + ' and a.idArea = ''' + @area + ''''
		end		

 SET @sql = N'
 
 SELECT
   * 
  FROM
  ( 
	select  e.empresa,
			e.codigo as Codigo, 							
			rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')) as Nombre,
			e.fchalta as fechaingreso,
			case tiponom
				when 1 then ''Semanal''
				when 2 then ''Decenal''
				when 3 then ''Catorcenal''
				when 4 then ''Quincenal''
				when 5 then ''Mensual''
				when 6 then ''Especial''
			end as tiponomina,
			isnull(valor,0) as valor,
			m.idoperacion
	FROM capaMatriz m			 
				 inner join empleados e  on e.empresa=m.empresa and e.codigo=m.codigo
				 inner join llaves ll on ll.empresa=e.empresa and ll.codigo=e.codigo
				 inner join capaMatriz_Calificaciones c on m.idCalificacion=c.idCalificacion and m.empresa=c.empresa
				 inner join capaMatriz_linea l on m.idLinea=l.idLinea and m.empresa=l.empresa
				 inner join capaMatriz_lineaArea la on l.idLinea=la.idLinea and l.empresa=la.empresa
				 inner join capaMatriz_area a on la.idArea=a.idArea and la.empresa=a.empresa				 
				 inner join capaMatriz_Operacion o on m.idOperacion=o.idOperacion and m.empresa=o.empresa 
				 inner join capa_ArchivosFirmas cf on cf.empresa=e.empresa
	 ' + @cWhereClause	+ '

  ) AS T
  PIVOT   
  (
  SUM(valor)
  FOR idoperacion IN (' + (SELECT STUFF(
								 (
								 SELECT
								   ',' + QUOTENAME(LTRIM(idoperacion))
								 FROM
								   (SELECT DISTINCT idoperacion
									FROM capaMatriz_Operacion
								   ) AS T
								 ORDER BY
								 idoperacion
								 FOR XML PATH('')
								 ), 1, 1, '')) + N')
								  ) AS P;'; 
 EXEC sp_executesql  @sql;

END

GO



if exists (select * from dbo.sysobjects where id = object_id(N'dbo.ObtenMatrizValorDeHabilidad') and xtype in (N'FN', N'IF', N'TF'))
	drop function dbo.ObtenMatrizValorDeHabilidad
GO

CREATE FUNCTION dbo.ObtenMatrizValorDeHabilidad
(
	@empresa bigint,
	@codigo bigint,
	@idoperacion varchar(200),
	@fechainicial datetime,
	@fechafinal datetime
)
RETURNS BIGINT -- VARCHAR(MAX)
AS
BEGIN
	 
	declare @regresa as BIGINT -- VARCHAR(MAX)
					
	select @regresa=ISNULL(sum(valor),0)
	from capamatriz m
		left join capaMatriz_Calificaciones c on m.idcalificacion=c.idCalificacion and m.empresa=c.empresa 
		left join capaMatriz_OperacionLinea ol on m.idLinea=ol.idLinea and m.empresa=ol.empresa and m.idOperacion=ol.idOperacion
		left join capaMatriz_LineaArea la on la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
	WHERE M.empresa =  convert(varchar(10),@Empresa) 
			and m.fecha >= @fechainicial and m.fecha<= @fechaFinal
			and m.idOperacion= @idOperacion 
			and codigo= convert(varchar(10),@codigo)	
	GROUP BY m.EMPRESA, m.codigo, m.idLinea,m.idOperacion
	RETURN @REGRESA
END
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizReportePivotEncabezados')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizReportePivotEncabezados
GO
CREATE PROCEDURE dbo.CapaMatrizReportePivotEncabezados(
    @idEmpresa bigint,
    @codigo bigint,
	@fechaDe datetime,
	@fechaA datetime,
	@linea varchar(50),
	@area varchar(25)
)
AS
BEGIN

	SET NOCOUNT ON
	SET DATEFORMAT MDY
    SET XACT_ABORT ON

	BEGIN TRY   

    declare @query nvarchar(max)
	declare @outputQueryColumns nvarchar(max)
	declare @outputQueryColumnsForUpdate nvarchar(max)
	declare @outputQueryColumnsSinTipo nvarchar(max)
	declare @outputQueryvalores nvarchar(max)
	declare @outputQueryvaloresEnCero nvarchar(max)
	declare @cFunciones nvarchar(max)
	declare @contador int=1
	declare @cantidadColumnas int
	DECLARE @timestamp NVARCHAR(255) = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(NVARCHAR(23), GETDATE(), 121),'-',''),' ',''),':',''),'.','')
	DECLARE @temp NVARCHAR(30) = '##temporalResultado'
	set @cantidadColumnas=0
	declare @existeInformacion int=0
	
	IF OBJECT_ID(N'tempdb..##temporalResultado') IS NOT NULL		
	BEGIN
		DROP TABLE ##temporalResultado
	END

	select @existeInformacion=count(o.idoperacion)
	FROM capaMatriz_Operacion o
		left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
		left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
	where ol.idLinea=@linea
	and ol.idArea=@area
	and ol.empresa=@idEmpresa

	if @existeinformacion>0
	begin

		set @outputQueryColumnsForUpdate= (SELECT STUFF(
			(
			SELECT
			', ' + QUOTENAME(LTRIM(idoperacion)) 
			+ '= isnull(dbo.ObtenMatrizValorDeHabilidad('+  convert(varchar(10),@idEmpresa)
			+',codigo,''' 
			+ LTRIM(idoperacion) 
			+ ''',''' + convert(varchar(10),@fechaDe,112) + ''',''' +  convert(varchar(10),@fechaA,112) + ' 11:59:59''),0)'  
			FROM
			(SELECT DISTINCT o.idoperacion
			FROM capaMatriz_Operacion o
				left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
				left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			where ol.idLinea=@linea
			and ol.idArea=@area
			and o.empresa=@idEmpresa
			) AS T
			ORDER BY
			idoperacion
			FOR XML PATH('')
			), 1, 1, ''))

		set @outputQueryVAlores= (SELECT STUFF(
			(
			SELECT
			',isnull(dbo.ObtenMatrizValorDeHabilidad(e.empresa,e.codigo,''' + LTRIM(idoperacion) + ''',''' + convert(varchar(10),@fechaDe,112) + ''',''' +  convert(varchar(10),@fechaA,112) + ' 11:59:59''),0)' 
			FROM
			(SELECT DISTINCT o.idoperacion
			FROM capaMatriz_Operacion o
				left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
				left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			where ol.idLinea=@linea
			and ol.idArea=@area
			and o.empresa=@idEmpresa
			) AS T
			ORDER BY
			idoperacion
			FOR XML PATH('')
			), 1, 1, ''))

		set @outputQueryVAloresEnCero=(SELECT STUFF(
			(
			SELECT
			',0'
			FROM
			(SELECT DISTINCT o.idOperacion 
			FROM capaMatriz_Operacion o
				left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
				left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			where ol.idLinea=@linea
			and ol.idArea=@area
			and o.empresa=@idEmpresa
			) AS T
			ORDER BY
			idoperacion
			FOR XML PATH('')
			), 1, 1, ''))

		set @outputQueryColumns= (SELECT STUFF(
			(
			SELECT
			',' + QUOTENAME(LTRIM(idoperacion)) + ' int'
			FROM
			(SELECT DISTINCT o.idoperacion
			FROM capaMatriz_Operacion o
				left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
				left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			where ol.idLinea=@linea
			and ol.idArea=@area
			and o.empresa=@idEmpresa
			) AS T
			ORDER BY
			idoperacion
			FOR XML PATH('')
			), 1, 1, ''))

		set @outputQueryColumnsSinTipo= (SELECT STUFF(
			(
			SELECT
			',' + QUOTENAME(LTRIM(idoperacion)) 
			FROM
			(SELECT DISTINCT o.idoperacion
			FROM capaMatriz_Operacion o
				left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
				left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			where ol.idLinea=@linea
			and ol.idArea=@area
			and o.empresa=@idEmpresa
			) AS T
			ORDER BY
			idoperacion
			FOR XML PATH('')
			), 1, 1, ''))

			SET @query = ' CREATE TABLE ' + @temp + ' (Codigo bigint, Nombre varchar(100), TipoNomina varchar(10), Antiguedad varchar(10), ' +  @outputQueryColumns + ')'
			EXECUTE sp_executesql @query

			set @query =' insert into ' + @temp + ' (codigo,nombre,tiponomina,antiguedad,' + @outputQueryColumnsSinTipo  + ')  
											select distinct(e.codigo), 							
											rtrim(isnull(e.nombre,'''')) + '' '' + rtrim(isnull(e.ap_paterno,'''')) + '' '' + rtrim(isnull(e.ap_materno,'''')),
											case tiponom
												when 1 then ''Semanal''
												when 2 then ''Decenal''
												when 3 then ''Catorcenal''
												when 4 then ''Quincenal''
												when 5 then ''Mensual''
												when 6 then ''Especial''
											end,
											convert(varchar(10),e.fchantigua,103), '
											+ 
											@outputQueryVAloresEnCero
											 + ' FROM  empleados e 			 
												left join capaMatriz m on e.empresa=m.empresa and e.codigo=m.codigo
												left join capamatriz_operacion o on o.idoperacion=m.idoperacion and o.empresa=m.empresa
												left join capamatriz_operacionLinea ol on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion and m.idlinea=ol.idlinea
												left join capaMatriz_LineaArea la on la.empresa=ol.empresa and la.idLinea=ol.idLinea and ol.idarea=la.idarea
		
											 inner join llaves ll on ll.empresa=e.empresa and ll.codigo=e.codigo
											 where iif(' + convert(varchar(10),@codigo) + '=0,0,e.codigo)=iif(' + convert(varchar(10),@codigo) + '=0,0,' + convert(varchar(10),@codigo)  + ')' + 
											 ' and ol.idLinea=''' + @linea + ''' ' + 
											 ' and ol.idArea=''' + @area + ''' ' + 
											 ' and e.empresa = ' + convert(varchar(10),@idEmpresa) +
											 ' and m.fecha between ''' + convert(varchar(10),@fechaDe,112) + ''' and ''' +  convert(varchar(10),@fechaA,112) + ' 11:59:59'''
											 print @query
			EXECUTE sp_executesql @query	

			set @query ='update ' + @temp + ' set ' + @outputQueryColumnsForUpdate 
			EXECUTE sp_executesql @query	

			set @query = 'select * from ' + @temp
			EXECUTE sp_executesql @query
	end

	if @existeInformacion<=0
		begin
			select @existeInformacion
		end

	END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
								+ CHAR(13) + CHAR(10) + 'Severity: '
								+ LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
								+ 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
								+ CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
								+ 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
								+ 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
		
END

GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCargaOperacionPorLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCargaOperacionPorLinea
GO

CREATE PROCEDURE dbo.CapaMatrizCargaOperacionPorLinea
	( @companyID bigint, @idarea varchar(50),@idLinea varchar(25)) 
AS 
	BEGIN	
		SELECT ol.idOperacion,o.nombre
		FROM capamatriz_operacionLinea ol 
			left join capamatriz_operacion o on o.empresa=ol.empresa and o.idOperacion=ol.idoperacion
			left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
		WHERE o.empresa = @companyID
		and ol.idlinea=@idlinea
		and la.idArea=@idarea

	end
go  


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizGuardaOperacionPorLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizGuardaOperacionPorLinea
GO

CREATE PROCEDURE dbo.CapaMatrizGuardaOperacionPorLinea
	(	@empresa bigint,
		@idarea varchar(25),
		@idlinea varchar(50),
		@idOperacion varchar(200)
	) 
AS 
	BEGIN	
	
	insert into capaMatriz_OperacionLinea(empresa, idarea,idlinea,idoperacion)
	values(@empresa,@idarea,@idLinea,@idOperacion)
	
	END
go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaOperacionDeLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaOperacionDeLinea
GO

CREATE PROCEDURE dbo.CapaMatrizEliminaOperacionDeLinea
	(	@empresa bigint,
		@idarea varchar(25),
		@idlinea varchar(50),
		@idOperacion varchar(200)
	) 
AS 
	BEGIN	
	
		delete from capaMatriz_OperacionLinea
		where idOperacion=@idOperacion
		and idarea=@idarea
		and idLinea=@idLinea
		and empresa=@empresa
	
	END
go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizEliminaOperacionDeLineaValida')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizEliminaOperacionDeLineaValida
GO
					 
CREATE PROCEDURE dbo.CapaMatrizEliminaOperacionDeLineaValida
	(	@empresa bigint,
		@idarea varchar(25),
		@idlinea varchar(50),
		@idOperacion varchar(200)
	) 
AS 
	BEGIN	
	
		select COUNT(codigo)
		from capaMatriz m
			left join capamatriz_operacionLinea ol on m.idOperacion=ol.idOperacion and m.empresa=ol.empresa and m.idLinea=ol.idLinea
			left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
		where m.idOperacion=@idOperacion
		and la.idarea=@idarea
		and m.idLinea=@idLinea
		and m.empresa=@empresa
	
	END
go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.CapaMatrizCatalogoOperacionPorLinea')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.CapaMatrizCatalogoOperacionPorLinea
GO
					 
CREATE PROCEDURE dbo.CapaMatrizCatalogoOperacionPorLinea
	(	@empresa bigint,
		@idarea varchar(25),
		@idlinea varchar(50)
	) 
AS 
	BEGIN	
	
		select m.empresa, 
				ol.idArea, 
				a.nombre as nombreArea,  
				l.idLinea,
				l.nombre as nombreLinea,
				m.idOperacion, 
				m.nombre as nombreOperacion
		from capaMatriz_Operacion m
			left join capamatriz_operacionLinea ol on m.idOperacion=ol.idOperacion and m.empresa=ol.empresa 
			left join capaMatriz_LineaArea la on  la.empresa=ol.empresa and la.idArea=ol.idArea and la.idLinea=ol.idlinea
			left join capaMatriz_Area a on la.empresa=m.empresa and la.idarea=a.idarea
			left join capaMatriz_Linea l on l.empresa=m.empresa and l.idLinea=la.idLinea and l.idLinea=ol.idLinea			
		where  la.idarea=@idarea
		and l.idLinea=@idLinea
		and m.empresa=@empresa
		order by a.idArea, l.orden, m.orden
	END
go
