
IF NOT EXISTS ( SELECT  1
				FROM    systypes
				WHERE   name = 'udtBoolean' ) 
    CREATE TYPE udtBoolean FROM BIT    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtByte' ) 
    CREATE TYPE udtByte FROM TINYINT    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtDateTime' ) 
   CREATE TYPE udtDateTime FROM DATETIME    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtFloat' ) 
    CREATE TYPE udtFloat FROM FLOAT    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtId' ) 
    CREATE TYPE udtId FROM BIGINT NOT NULL   
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtInteger' )     
	CREATE TYPE udtInteger FROM INT    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtLong' ) 
    CREATE TYPE udtLong FROM BIGINT    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtName' ) 
   CREATE TYPE udtName FROM VARCHAR(50)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtNameId' ) 
    CREATE TYPE udtNameId FROM VARCHAR(50) NOT NULL    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize1024' )         
	CREATE TYPE udtStringSize1024 FROM VARCHAR(1024)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize128' ) 
    CREATE TYPE udtStringSize128 FROM VARCHAR(128)   
    go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize2048' ) 
    CREATE TYPE udtStringSize2048 FROM VARCHAR(2048)
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize255' ) 
    CREATE TYPE udtStringSize255 FROM VARCHAR(255)
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize4096' ) 
    CREATE TYPE udtStringSize4096 FROM VARCHAR(4096)
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize512' ) 
    CREATE TYPE udtStringSize512 FROM VARCHAR(512)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize8000' ) 
    CREATE TYPE udtStringSize8000 FROM VARCHAR(8000)   
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtText' ) 
    CREATE TYPE udtText FROM TEXT
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtStringSize15' ) 
    CREATE TYPE udtStringSize15 FROM VARCHAR(15)
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtDecimal6_2' ) 
   CREATE TYPE udtDecimal6_2 FROM Decimal(6,2)
    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtDecimal10_2' ) 
    CREATE TYPE udtDecimal10_2 FROM Decimal(10,2)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtNumeric1' ) 
    CREATE TYPE udtNumeric1  FROM NUMERIC(12,2)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtNumeric2' ) 
    CREATE TYPE udtNumeric2  FROM NUMERIC(12,6)    
go

IF NOT EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtNumeric3' )   
	CREATE TYPE udtNumeric3  FROM NUMERIC(10,4)    
go

IF NOT  EXISTS ( SELECT  1
            FROM    systypes
            WHERE   name = 'udtNumeric4' ) 
   CREATE TYPE udtNumeric4  FROM NUMERIC(12,4)    
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetInstitution'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetInstitution
    
GO

CREATE PROCEDURE  dbo.GetInstitution
    @companyId udtInteger,
    @institutionId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = ' SELECT  Capa_Institucion.idInstitucion ,
								Capa_Institucion.Clave ,
								Capa_Institucion.Nombre ,
								Capa_Institucion.Direccion ,
								Capa_Institucion.Ciudad ,
								Capa_Institucion.Estado ,
								Capa_Institucion.Telefono ,
								Capa_Institucion.Fax ,
								Capa_Institucion.Contacto ,
								Capa_Institucion.Email ,
								Capa_Institucion.fechaAlta ,
								Capa_Institucion.rfc '             

		SET @cFromClause = ' From Capa_Institucion '
		
		SET @cWhereClause = ' Where Capa_Institucion.empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @institutionId > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and Capa_Institucion.idInstitucion = ' + CONVERT(VARCHAR(5),@institutionId)                      
			END
		
        SET @cOrderByClause = ' Order By Capa_Institucion.Clave '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewInstitution'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewInstitution
    
GO


CREATE PROCEDURE  dbo.NewInstitution
    @companyId udtInteger,
    @clave udtName,
    @nombre udtName,
    @direccion udtName,
    @ciudad udtName,
    @estado udtName,
    @telefono udtName,
    @fax udtName,
    @contacto udtName,
    @email udtName,
    @rfc udtName   
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        INSERT INTO Capa_Institucion (
                Capa_Institucion.empresa ,
				Capa_Institucion.Clave ,
				Capa_Institucion.Nombre ,
				Capa_Institucion.Direccion ,
				Capa_Institucion.Ciudad ,
				Capa_Institucion.Estado ,
				Capa_Institucion.Telefono ,
				Capa_Institucion.Fax ,
				Capa_Institucion.Contacto ,
				Capa_Institucion.Email ,
				Capa_Institucion.fechaAlta ,
				Capa_Institucion.rfc) 
		VALUES		(@companyId, 
					@clave,
					@nombre,
					@direccion,
					@ciudad,
					@estado,
					@telefono,
					@fax,
					@contacto,
					@email,
					GETDATE(),
					@rfc)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteInstitution'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteInstitution
GO

CREATE PROCEDURE  dbo.DeleteInstitution
    @companyId udtInteger, 
    @institutionId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM capa_Institucion 
        WHERE Capa_Institucion.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Institucion.idInstitucion =  + CONVERT(VARCHAR(5),@institutionId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateInstitution'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateInstitution
GO

CREATE PROCEDURE  dbo.UpdateInstitution
    @institutionId udtInteger,
    @companyId udtInteger,
    @clave udtName,
    @nombre udtName,
    @direccion udtName,
    @ciudad udtName,
    @estado udtName,
    @telefono udtName,
    @fax udtName,
    @contacto udtName,
    @email udtName,
    @rfc udtName 
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        UPDATE Capa_Institucion 
        SET Capa_Institucion.Clave = @clave,
			Capa_Institucion.Nombre =@nombre,
			Capa_Institucion.Direccion =@direccion,
			Capa_Institucion.Ciudad =@ciudad,
			Capa_Institucion.Estado =@estado,
			Capa_Institucion.Telefono =@telefono,
			Capa_Institucion.Fax =@fax,
			Capa_Institucion.Contacto =@contacto,
			Capa_Institucion.Email =@email	,			
			Capa_Institucion.rfc = @rfc	 
		WHERE Capa_Institucion.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Institucion.idInstitucion =  + CONVERT(VARCHAR(5),@institutionId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO




IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetInstructor
    
GO

CREATE PROCEDURE  dbo.GetInstructor
    @companyId udtInteger,
    @instructorId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = '	SELECT capa_Instructor.empresa,
								capa_Instructor.idInstructor,
								capa_Instructor.nombre,
								capa_Instructor.rfc,
								capa_Instructor.direccion,
								capa_Instructor.idCiudad,
								capa_Instructor.idEstado,
								capa_Instructor.Telefono,
								capa_Instructor.Email,
								capa_Instructor.FechaRegistro,
								capa_Instructor.idInstitucion,
								capa_Instructor.Externo,
								capa_Instructor.registroSTPS,
								capa_Instructor.fechaalta'             

		SET @cFromClause = ' From capa_Instructor '
		
		SET @cWhereClause = ' Where capa_Instructor.empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @instructorId > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and capa_Instructor.idInstructor = ' + CONVERT(VARCHAR(5),@instructorId)                      
			END
		
        SET @cOrderByClause = ' Order By capa_Instructor.idInstructor '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewInstructor
    
GO


CREATE PROCEDURE  dbo.NewInstructor
	@companyId udtInteger,
    @nombre udtName,
    @rfc udtName,
    @direccion udtName,
    @idCiudad udtInteger,
    @idEstado udtInteger,
    @telefono udtName,
    @email udtName,       
    @fechaRegistro udtDateTime,
    @idInstitucion udtInteger,
    @externo udtName,
    @registroSTPS udtName    
                   
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        INSERT INTO Capa_Instructor (
                Capa_Instructor.empresa ,
				Capa_Instructor.Nombre ,
				Capa_Instructor.rfc,
				Capa_Instructor.Direccion ,
				Capa_Instructor.idCiudad ,
				Capa_Instructor.idEstado ,
				Capa_Instructor.Telefono ,
				Capa_Instructor.Email ,
				Capa_Instructor.FechaRegistro ,
				Capa_Instructor.idInstitucion ,
				Capa_Instructor.Externo ,
				Capa_Instructor.registroSTPS ) 
		VALUES	(@companyId, 
				@nombre,
				@rfc,	 
				@direccion,
				@idCiudad,
				@idEstado,
				@telefono,
				@email,			
				@fechaRegistro,
				@idInstitucion,
				@externo,			
				@registroSTPS)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteInstructor
GO

CREATE PROCEDURE  dbo.DeleteInstructor
    @companyId udtInteger, 
    @instructorId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_Instructor 
        WHERE Capa_Instructor.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Instructor.idInstructor =  + CONVERT(VARCHAR(5),@instructorId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateInstructor
GO

CREATE PROCEDURE  dbo.UpdateInstructor    
    @companyId udtInteger,
    @instructorId udtInteger,
    @nombre udtName,
    @rfc udtName ,
    @direccion udtName,
    @idCiudad udtInteger,
    @idEstado udtInteger,
    @telefono udtName,
    @email udtName,       
    @fechaRegistro udtDateTime,
    @idInstitucion udtInteger,
    @externo udtName,
    @registroSTPS udtName    
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        UPDATE Capa_Instructor 
        SET Capa_Instructor.nombre = @nombre,
			Capa_Instructor.rfc = @rfc,	 
			Capa_Instructor.Direccion =@direccion,
			Capa_Instructor.idCiudad = @idCiudad,
			Capa_Instructor.idEstado = @idEstado,
			Capa_Instructor.Telefono = @telefono,
			Capa_Instructor.Email = @email,			
			Capa_Instructor.FechaRegistro = @fechaRegistro,
			Capa_Instructor.idInstitucion = @idInstitucion,
			Capa_Instructor.Externo = @externo,			
			Capa_Instructor.registroSTPS = @registroSTPS
		WHERE Capa_Instructor.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Instructor.idInstructor =  + CONVERT(VARCHAR(5),@instructorId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
Go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetCourseContent'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetCourseContent
    
GO

CREATE PROCEDURE  dbo.GetCourseContent
    @companyId udtInteger,
    @courseContentId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa
							  ,idtemario
							  ,nombre
							  ,descripcion
							  ,ubicacion'       

		SET @cFromClause = ' From capa_temario '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @courseContentId > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idTemario = ' + CONVERT(VARCHAR(5),@courseContentId)                      
			END
		
        SET @cOrderByClause = ' Order By idTemario '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewCourseContent'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewCourseContent
    
GO


CREATE PROCEDURE  dbo.NewCourseContent
	@courseContentId udtInteger,
    @companyId udtInteger,
    @name udtName,
    @description udtName,
    @location udtName  
                   
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_temario (
                Capa_temario.empresa ,
				Capa_temario.nombre ,
				Capa_temario.descripcion,
				Capa_temario.ubicacion ) 
		VALUES	(@companyId, 
				@name,
				@description,	 
				@location)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteCourseContent'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteCourseContent
GO

CREATE PROCEDURE  dbo.DeleteCourseContent
    @companyId udtInteger, 
    @courseContentId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_temario 
        WHERE Capa_temario.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_temario.idtemario =  + CONVERT(VARCHAR(5),@courseContentId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateCourseContent'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateCourseContent
GO
       
CREATE PROCEDURE  dbo.UpdateCourseContent    
	@courseContentId udtInteger,
    @companyId udtInteger,
    @name udtName,
    @description udtName,
    @location udtName    
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_temario 
        SET Capa_temario.nombre = @name,
			Capa_temario.descripcion = @description,	 
			Capa_temario.ubicacion = @location
		WHERE Capa_temario.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_temario.idTemario =  + CONVERT(VARCHAR(5),@courseContentId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetCourseType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetCourseType
    
GO

CREATE PROCEDURE  dbo.GetCourseType
    @companyId udtInteger,
    @courseType udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, idtipocurso, nombre'       

		SET @cFromClause = ' From capa_TipoCurso '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @courseType > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idTemario = ' + CONVERT(VARCHAR(5),@courseType)                      
			END
		
        SET @cOrderByClause = ' Order By idTipoCurso '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewCourseType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewCourseType
    
GO


CREATE PROCEDURE  dbo.NewCourseType
	@courseTypeId udtInteger,
    @companyId udtInteger,
    @name udtName
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_TipoCurso (
                Capa_temario.empresa ,
				Capa_temario.nombre ) 
		VALUES	(@companyId, 
				@name)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteCourseType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteCourseType
GO

CREATE PROCEDURE  dbo.DeleteCourseType
    @companyId udtInteger, 
    @courseTypeId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_TipoCurso
        WHERE Capa_TipoCurso.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_TipoCurso.idTipoCurso =  + CONVERT(VARCHAR(5),@courseTypeId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateCourseType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateCourseType
GO
       
CREATE PROCEDURE  dbo.UpdateCourseType    
	@courseTypeId udtInteger,
    @companyId udtInteger,
    @name udtName   
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_TipoCurso
        SET Capa_TipoCurso.nombre = @name
		WHERE Capa_TipoCurso.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_TipoCurso.idTipoCurso =  + CONVERT(VARCHAR(5),@courseTypeId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetCourseLocation'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetCourseLocation
    
GO

CREATE PROCEDURE  dbo.GetCourseLocation
    @companyId udtInteger,
    @courseLocation udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, idLugar, Lugar'       

		SET @cFromClause = ' From capa_Lugar '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @courseLocation > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idLugar = ' + CONVERT(VARCHAR(5),@courseLocation)                      
			END
		
        SET @cOrderByClause = ' Order By idLugar '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewCourseLocation'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewCourseLocation
    
GO

CREATE PROCEDURE  dbo.NewCourseLocation
	@courseLocationId udtInteger,
    @companyId udtInteger,
    @name udtName
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_Lugar (
                Capa_Lugar.empresa ,
				Capa_Lugar.Lugar ) 
		VALUES	(@companyId, @name)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteCourseLocation'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteCourseLocation
GO

CREATE PROCEDURE  dbo.DeleteCourseLocation
    @companyId udtInteger, 
    @courseLocationId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_Lugar
        WHERE Capa_Lugar.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Lugar.idLugar =  + CONVERT(VARCHAR(5),@courseLocationId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateCourseLocation'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateCourseLocation
GO
       
CREATE PROCEDURE  dbo.UpdateCourseLocation    
	@courseLocationId udtInteger,
    @companyId udtInteger,
    @name udtName   
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_Lugar
        SET Capa_Lugar.lugar = @name
		WHERE Capa_Lugar.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_Lugar.idLugar=  + CONVERT(VARCHAR(5),@courseLocationId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetGrades'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetGrades
    
GO

CREATE PROCEDURE  dbo.GetGrades
    @companyId udtInteger,
    @courseGrade udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, idCalificacion, Nombre, imagen, valor, orden'       

		SET @cFromClause = ' From capa_EvalCalificacion '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @courseGrade > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idCalificacion= ' + CONVERT(VARCHAR(5),@courseGrade)                      
			END
		
        SET @cOrderByClause = ' Order By Orden '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewGrade'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewGrade
    
GO

CREATE PROCEDURE  dbo.NewGrade
	@courseGradeId udtInteger,
    @companyId udtInteger,
    @name udtName,
    @image udtName,
    @value udtInteger,
    @order udtInteger
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_evalCalificacion (
                Capa_evalCalificacion.empresa ,
				Capa_evalCalificacion.nombre,
				Capa_evalCalificacion.imagen,
				Capa_evalCalificacion.valor,
				Capa_evalCalificacion.orden ) 
		VALUES	(@companyId, @name, @image, @value, @order)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteGrade'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteGrade
GO

CREATE PROCEDURE  dbo.DeleteGrade
    @companyId udtInteger, 
    @courseGradeId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_evalCalificacion
        WHERE Capa_evalCalificacion.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalCalificacion.idCalificacion =  + CONVERT(VARCHAR(5),@courseGradeId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateGrade'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateGrade
GO
       
CREATE PROCEDURE  dbo.UpdateGrade    
	@courseGradeId udtInteger,
    @companyId udtInteger,
    @name udtName,
    @image udtName,
    @value udtInteger,
    @order udtInteger   
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_evalCalificacion
        SET Capa_evalCalificacion.nombre = @name,
        Capa_evalCalificacion.valor = @value,
        Capa_evalCalificacion.orden = @order
		WHERE Capa_evalCalificacion.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalCalificacion.idCalificacion=  + CONVERT(VARCHAR(5),@courseGradeId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetQuestionType '
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetQuestionType
    
GO

CREATE PROCEDURE  dbo.GetQuestionType
    @companyId udtInteger,
    @HeaderFooterTypeId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, idTipo, Tipo'       

		SET @cFromClause = ' From [capa_EvaltipoPregunta] '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @HeaderFooterTypeId > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idTipo= ' + CONVERT(VARCHAR(5),@HeaderFooterTypeId)                      
			END
		
        SET @cOrderByClause = ' Order By idTipo '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewQuestionType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewQuestionType
    
GO

CREATE PROCEDURE  dbo.NewQuestionType	
    @companyId udtInteger,
    @name udtName
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_evalTipoPregunta (
                Capa_evalCalificacion.empresa ,
				Capa_evalCalificacion.Tipo) 
		VALUES	(@companyId, @name)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteQuestionType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteQuestionType
GO

CREATE PROCEDURE  dbo.DeleteQuestionType
    @companyId udtInteger, 
    @HeaderFooterTypeId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_evalTipoPregunta
        WHERE Capa_evalTipoPregunta.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalTipoPregunta.idTipo =  + CONVERT(VARCHAR(5),@HeaderFooterTypeId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateQuestionType'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateQuestionType
GO
       
CREATE PROCEDURE  dbo.UpdateQuestionType    
	@HeaderFooterTypeId udtInteger,
    @companyId udtInteger,
    @name udtName 
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_evalTipoPregunta
        SET Capa_evalTipoPregunta.Tipo = @name
		WHERE Capa_evalTipoPregunta.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalTipoPregunta.idTipo=  + CONVERT(VARCHAR(5),@HeaderFooterTypeId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetQuestion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetQuestion
    
GO

CREATE PROCEDURE  dbo.GetQuestion
    @companyId udtInteger,
    @questionId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, idPregunta, idTipo, texto, orden'       

		SET @cFromClause = ' From [capa_EvalPregunta] '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
		
		IF @questionId > 0 
			BEGIN
				SET @cWhereClause = @cWhereClause + ' and idPregunta= ' + CONVERT(VARCHAR(5),@questionId)                      
			END
		
        SET @cOrderByClause = ' Order By orden '
        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewQuestion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewQuestion
    
GO

CREATE PROCEDURE  dbo.NewQuestion	
    @companyId udtInteger,
    @typeId udtInteger,
    @text udtName,
    @order udtInteger
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_evalPregunta (
                Capa_evalPregunta.empresa ,
				Capa_evalPregunta.idTipo,
				Capa_evalPregunta.Texto,	
				Capa_evalPregunta.orden) 
		VALUES	(@companyId, @typeId, @text, @order)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'DeleteQuestion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.DeleteQuestion
GO

CREATE PROCEDURE  dbo.DeleteQuestion
    @companyId udtInteger, 
    @questionId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
        DELETE FROM Capa_evalPregunta
        WHERE Capa_evalPregunta.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalPregunta.idPregunta =  + CONVERT(VARCHAR(5),@questionId)                      
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateQuestion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateQuestion
GO
       
CREATE PROCEDURE  dbo.UpdateQuestion    
	@questionId udtInteger,
    @companyId udtInteger,
    @text udtName ,
    @order udtInteger,
    @typeId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_evalPregunta
        SET Capa_evalPregunta.idTipo = @typeId,
        Capa_evalPregunta.texto = @text,
        Capa_evalPregunta.orden = @order
		WHERE Capa_evalPregunta.empresa = CONVERT(VARCHAR(5),@companyId) 
        AND Capa_evalPregunta.idPregunta=  + CONVERT(VARCHAR(5),@questionId)
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects 
            WHERE   name = 'GetHeaderFooter'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.GetHeaderFooter
    
GO

CREATE PROCEDURE  dbo.GetHeaderFooter
    @companyId udtInteger,
    @HeaderFooterId udtInteger
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
		DECLARE @cSelectClause udtStringSize1024
		DECLARE @cFromClause udtStringSize1024
		DECLARE @cWhereClause udtStringSize1024
		DECLARE @cOrderByClause udtStringSize1024
		
        SET @cSelectClause = 'SELECT empresa, encabezado, pie'       

		SET @cFromClause = ' From [capa_EvalEncabezado] '
		
		SET @cWhereClause = ' Where empresa = ' + CONVERT(VARCHAR(5),@companyId) 
				        
        EXEC (  @cSelectClause + @cFromClause + @cWhereClause + @cOrderByClause  )
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'NewHeaderFooter'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.NewHeaderFooter
    
GO

CREATE PROCEDURE  dbo.NewHeaderFooter	
    @companyId udtInteger,
    @header udtInteger,
    @footer udtName
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
            
        INSERT INTO Capa_evalEncabezado (
                Capa_evalEncabezado.empresa ,
				Capa_evalEncabezado.encabezado,
				Capa_evalEncabezado.pie) 
		VALUES	(@companyId, @header, @footer)            
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'UpdateHeaderFooter'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.UpdateHeaderFooter
GO
       
CREATE PROCEDURE  dbo.UpdateHeaderFooter    
    @companyId udtInteger,
    @header udtName ,
    @footer udtName
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
        UPDATE Capa_evalEncabezado
        SET Capa_evalEncabezado.encabezado = @header,
        Capa_evalEncabezado.pie = @footer
		WHERE Capa_evalEncabezado.empresa = CONVERT(VARCHAR(5),@companyId) 
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaCatalogoAreaGuarda'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaCatalogoAreaGuarda
    
GO

CREATE PROCEDURE  dbo.capaCatalogoAreaGuarda	
  (  @empresa bigint,
    @idArea bigint,
    @clave varchar(15),
    @nombre varchar(50))
                      
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
	IF @idArea=0
		INSERT INTO capa_CatalogoArea(empresa,idArea,clave,nombre)
		VALUES
			(@empresa
			,(select isnull(max(idArea),0)+1 from capa_CatalogoArea where empresa=@empresa)
			,@clave
			,@nombre)         
	ELSE IF @idArea>0
			UPDATE capa_CatalogoArea
			SET 
			  clave  = @clave,
			  nombre = @nombre
		 WHERE idArea =@idArea and empresa=@empresa

                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaCatalogoAreaElimina'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaCatalogoAreaElimina
GO

CREATE PROCEDURE  dbo.capaCatalogoAreaElimina
   ( @empresa bigint, 
    @IdArea bigint)
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
    DELETE FROM capa_CatalogoArea
    WHERE idarea = @IdArea
    AND empresa=@empresa
			
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaCatalogoAreaListado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaCatalogoAreaListado
GO
       
CREATE PROCEDURE  dbo.capaCatalogoAreaListado    
	(@empresa bigint)
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
	  SELECT idArea
		  ,clave
		  ,nombre
	  FROM capa_CatalogoArea
	  where empresa=@empresa
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaCatalogoAreaValidaRelacion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaCatalogoAreaValidaRelacion
GO
       
CREATE PROCEDURE  dbo.capaCatalogoAreaValidaRelacion    
	(@empresa bigint,
	 @idArea bigint)
        
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
              
	  SELECT count(*)
	  FROM capa_Curso
	  where empresa=@empresa
	  and  idarea= @idArea
                
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO







