
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'relacionaOcupacionesAnterioresSTPS'
                    AND type = 'P' ) 
    DROP PROCEDURE [dbo].relacionaOcupacionesAnterioresSTPS
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'detalleCursosPorCentroCostos'
                    AND type = 'P' ) 
    DROP PROCEDURE [dbo].detalleCursosPorCentroCostos
GO

CREATE PROCEDURE  dbo.detalleCursosPorCentroCostos
 (
		@companyId AS Integer , 
		@costCenter as varchar(2500),
		@beginDate as Datetime,
		@endDate as DateTime
    )

    WITH ENCRYPTION
    
AS 
	SET NOCOUNT ON
    SET DATEFORMAT MDY
    
    declare @selectStatement as varchar(2048) 
    declare @fromStatement as varchar(2048) 
    declare @whereStatement as varchar(2048)           
    declare @orderbyStatement as varchar(1024)
    
    declare @centros as varchar(2048)
    
    set @centros=''''  +  REPLACE ( @costCenter , ',' , ''',''' )  + ''''
    

	set @selectStatement = '  SELECT
								empresas.registro_patronal,								
								empresas.rfc_empresa,
								empresas.nombre_empresa as nombreEmpresa,
								capa_Programacion.empresa,
								capa_Programacion.idprogramacion,
								capa_Programacion.finicial,
								capa_Programacion.ffinal,
								capa_Programacion.horaini1,
								capa_Programacion.horafin1,
								capa_Programacion.horaini2,
								capa_Programacion.horafin2,
								capa_Programacion.tothoras,
								capa_Instructor.nombre as nombreInstructor,
								capa_EmpleadoProgramacion.empresa,
								capa_EmpleadoProgramacion.codigo,
								capa_EmpleadoProgramacion.idprogramacion,
								capa_EmpleadoProgramacion.calificacion,
								capa_EmpleadoProgramacion.asistencia,
								Capa_piedepagina.Reporte,
								Capa_piedepagina.lado,
								Capa_piedepagina.texto,
								Capa_piedepagina.ladoSup,
								Capa_piedepagina.TextoSup,
								capa_Curso.idcurso,
								capa_Curso.clave,
								capa_Curso.nombre as nombreCurso,
								empleados.codigo,
								empleados.nombre as nombreEmpleado,
								empleados.ap_paterno,
								empleados.ap_materno,
								Llaves.centro,
								centros.nomdepto,
								supervisores.nombre as nombreSupervisor'
		set @fromStatement =   ' FROM
								(((((((empresas empresas INNER JOIN capa_Programacion capa_Programacion ON
									empresas.empresa = capa_Programacion.empresa)
								LEFT OUTER JOIN capa_Instructor capa_Instructor ON
									capa_Programacion.empresa = capa_Instructor.empresa AND
									capa_Programacion.idInstructor = capa_Instructor.idInstructor)
								LEFT OUTER JOIN capa_EmpleadoProgramacion capa_EmpleadoProgramacion ON
									capa_Programacion.empresa = capa_EmpleadoProgramacion.empresa AND
									capa_Programacion.idprogramacion = capa_EmpleadoProgramacion.idprogramacion)
								LEFT OUTER JOIN Capa_piedepagina Capa_piedepagina ON
									capa_Programacion.empresa = Capa_piedepagina.empresa)
								INNER JOIN capa_Curso capa_Curso ON
									capa_Programacion.empresa = capa_Curso.empresa AND
									capa_Programacion.idcurso = capa_Curso.idcurso)
								LEFT OUTER JOIN empleados empleados ON
									capa_EmpleadoProgramacion.empresa = empleados.empresa AND
									capa_EmpleadoProgramacion.codigo = empleados.codigo)
								INNER JOIN Llaves Llaves ON
									empleados.empresa = Llaves.empresa AND
									empleados.codigo = Llaves.codigo)
								INNER JOIN centros centros ON
									Llaves.centro = centros.centro AND
									Llaves.empresa = centros.empresa
								left join supervisores on 
									llaves.empresa=supervisores.empresa and
									llaves.supervisor=supervisores.supervisor'
        
	set @whereStatement =  ' WHERE
							capa_Programacion.empresa = ' + convert(varchar,@companyId,112) + ' AND
							Capa_piedepagina.Reporte = ''rptAvance'' AND
							capa_Programacion.finicial >= ''' + convert(varchar(50),@begindate,112) + '''
							AND
							capa_Programacion.finicial <= ''' +convert(varchar(50),@enddate,112) + ''' '
	if @costCenter<>''
		begin
			set @whereStatement = @whereStatement + ' and centros.centro in ('  + @centros +  ')'
		end
	
	
	set @orderbyStatement = ' ORDER BY
							Llaves.centro ASC,
							capa_Curso.idcurso ASC,
							capa_Programacion.idprogramacion ASC,
							empleados.codigo ASC'
							
 							
	exec ( @selectStatement + @fromStatement + @whereStatement + @orderbyStatement) 				
 
 GO
 
 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='estatus')
  ALTER TABLE  capa_Instructor ADD estatus VARCHAR(1) NULL
go


update capa_Instructor set estatus= 'A' where estatus is null
go