
update capa_programacion set modalidad=1 where modalidad is null
update capa_programacion set objetivo=1 where objetivo is null
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='imagenFirma')
  ALTER TABLE capa_Instructor ADD imagenFirma VARCHAR(500) NULL
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='imagenRepresentante')
  ALTER TABLE capa_Instructor ADD imagenRepresentante VARCHAR(500) NULL
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='imagenLogo')
  ALTER TABLE capa_Instructor ADD imagenLogo VARCHAR(500) NULL
go

 if exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='imagenRepresentante')
  ALTER TABLE capa_Instructor drop column imagenRepresentante
go

 if exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_Instructor' 
                 and c.name='imagenLogo')
  ALTER TABLE capa_Instructor drop column imagenLogo 
go

Update capa_Instructor
set imagenFirma='.\firmaBlanco.jpg'
where imagenFirma is null
go




if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[capa_ArchivosFirmas]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[capa_ArchivosFirmas](
	[empresa] [numeric](3, 0) NOT NULL,
	[logo] [varchar](500) NULL,
	[representanteLegal] [varchar](500) NULL,
	[representanteTrabajadores] [varchar](500) NULL,
 CONSTRAINT [PK_capa_ArchivosFirmas] PRIMARY KEY CLUSTERED 
(
	[empresa] ASC
) ON [PRIMARY]
) ON [PRIMARY]

GO


if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_ArchivosFirmas' 
                 and c.name='nombreEmpresa')
  ALTER TABLE  capa_ArchivosFirmas ADD nombreEmpresa VARCHAR(300) NULL
go

if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_ArchivosFirmas' 
                 and c.name='nombreTrabajadores')
  ALTER TABLE  capa_ArchivosFirmas ADD nombreTrabajadores VARCHAR(300) NULL
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaFirmasIniciales'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaFirmasIniciales
GO

CREATE PROCEDURE  dbo.capaInsertaFirmasIniciales
AS 
    BEGIN    
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON

    declare @existe int	
	declare @empresa numeric(3,0)
    DECLARE cEmpresa CURSOR

    FOR SELECT empresa FROM empresas 
	OPEN cEmpresa
	FETCH NEXT FROM cEmpresa into @empresa
		WHILE @@FETCH_STATUS = 0
		BEGIN
			select @existe=count(empresa) from capa_ArchivosFirmas where empresa=@empresa 
			
			if @existe=0
				begin
					INSERT INTO capa_ArchivosFirmas
						   (empresa
						   ,logo
						   ,representanteLegal
						   ,representanteTrabajadores)
					 VALUES
						   (@empresa
						   ,'.\firmaBlanco.jpg'
						   ,'.\firmaBlanco.jpg'
						   ,'.\firmaBlanco.jpg')
				end
			FETCH NEXT FROM cEmpresa into @empresa
		END
		
	
	CLOSE cEmpresa
	DEALLOCATE cEmpresa
	  
    END
GO

exec capaInsertaFirmasIniciales
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaActualizaFirmas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaActualizaFirmas
GO

CREATE PROCEDURE  dbo.capaActualizaFirmas
    (@companyId udtInteger,
     @logo varchar(500),
     @representanteLegal varchar(500),
     @representanteTrabajadores varchar(500),
     @nombreEmpresa varchar(300),
     @nombreTrabajadores varchar(300))
AS 
    BEGIN
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON  
    
    UPDATE capa_ArchivosFirmas
    SET logo = @logo
      ,representanteLegal = @representanteLegal
      ,representanteTrabajadores = @representanteTrabajadores  
      ,nombreEmpresa = @nombreEmpresa
      ,nombreTrabajadores = @nombreTrabajadores  
	WHERE empresa=@companyId
    
    END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaObtenFirmas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaObtenFirmas
GO

CREATE PROCEDURE  dbo.capaObtenFirmas
    (@companyId udtInteger)
AS 
    BEGIN
		SELECT empresa
		  ,logo
		  ,representanteLegal
		  ,representanteTrabajadores
		  ,nombreempresa
		  ,nombreTrabajadores
		FROM capa_ArchivosFirmas
		where empresa=@companyId
	end
GO

/************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaValidaRelacionTipoCurso'
                    AND type = 'FN' ) 
    DROP function dbo.capaValidaRelacionTipoCurso
GO

CREATE FUNCTION dbo.capaValidaRelacionTipoCurso
	(	
	@idempresa bigint,
	@idTipo varchar(10)
	) 
RETURNS int

	WITH ENCRYPTION
AS 
    BEGIN
        DECLARE @cantidad1 int                      
        
        SET @cantidad1 = 0
        
        select @cantidad1= count(idcurso)
        from capa_curso
        where idTipoCurso=@idtipo   
        
        RETURN (@cantidad1)
    END
GO

IF not EXISTS(select syscolumns.name  from syscolumns 
	left join sysobjects on syscolumns.id=sysobjects.id
	where syscolumns.name = 'rutaCarpeta' and sysobjects.name='capa_temario')
	Alter table dbo.capa_temario add rutaCarpeta varchar(500) null    	              
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaTemario
GO

CREATE PROCEDURE  dbo.capaInsertaTemario
    (@companyId udtInteger,
     @nombre varchar(50),
     @descripcion varchar(300),
     @ubicacion varchar(200),
     @RutaCarpeta varchar(500))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY
    
    
    INSERT INTO [capa_temario]
           ([empresa]
           ,[nombre]
           ,[descripcion]
           ,[ubicacion]
           ,[rutaCarpeta])
     VALUES
           (@companyId
           ,@nombre
           ,@descripcion
           ,@ubicacion
           ,@RutaCarpeta)

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaActualizaTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaActualizaTemario
GO

CREATE PROCEDURE  dbo.capaActualizaTemario
    (@companyId udtInteger,
    @IdTemario udtInteger,
    @nombre varchar(50),
    @descripcion varchar(300),
    @ubicacion varchar(200),
    @RutaCarpeta varchar(500))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
	UPDATE capa_temario
	   SET [nombre] = @nombre
		  ,[descripcion] = @descripcion
		  ,[ubicacion] = @ubicacion
		  ,[rutaCarpeta] = @RutaCarpeta
	 WHERE idtemario=@IdTemario 
	 and empresa = @companyId
		

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaValidaNombreTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaValidaNombreTemario
GO

CREATE PROCEDURE  dbo.capaValidaNombreTemario
    (@nombre varchar(50),
    @companyId udtInteger)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
	SELECT COUNT(*) 
	FROM capa_temario
	WHERE EMPRESA=@companyId
	AND nombre=@nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO       
            
            
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaCargaListadoTemarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaCargaListadoTemarios
GO

CREATE PROCEDURE  dbo.CapaCargaListadoTemarios
    (@companyId udtInteger)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
	SELECT [idtemario]
      ,[nombre]
      ,[descripcion]
      ,[ubicacion]
      ,[rutaCarpeta]
	FROM [capa_temario]
	WHERE empresa=@companyId
    order by nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

           
            
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaCargaDetalleTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaCargaDetalleTemario
GO

CREATE PROCEDURE  dbo.CapaCargaDetalleTemario
    (@companyId udtInteger,
    @temarioId udtInteger)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
	SELECT [idtemario]
      ,[nombre]
      ,[descripcion]
      ,[ubicacion]
      ,[rutaCarpeta]
	FROM [capa_temario]
	WHERE empresa=@companyId
	and idtemario=@temarioid
    order by nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

          
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaCargaListadoInstituciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaCargaListadoInstituciones
GO

CREATE PROCEDURE  dbo.CapaCargaListadoInstituciones
    (@companyId udtInteger)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
	
	SELECT isnull([idInstitucion],0) as id
		  ,isnull([clave],'') as clave
		  ,isnull([nombre],'') as nombre
		  ,isnull([ciudad],'') as ciudad
		  ,isnull([estado],'5') as estado
		  ,isnull(convert(varchar(10),[fechaalta],103),'19000101') as fecha
		  ,isnull([claveSTPS],'') as claveSTPS
	FROM [capa_Institucion]
	WHERE empresa=@companyId
    order by nombre

    END TRY
    
    BEGIN CATCH

    DECLARE @ErrorSeverity udtInteger
    DECLARE @ErrorState udtInteger
    DECLARE @ErrorMessage udtStringSize2048

    SET @ErrorSeverity = ERROR_SEVERITY()
    SET @ErrorState = ERROR_STATE()
    SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
						+ CHAR(13) + CHAR(10) + 'Severity: '
						+ LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
						+ 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
						+ CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
						+ 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
						+ 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

    RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

         
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaCargaDetalleInstitucion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaCargaDetalleInstitucion
GO

CREATE PROCEDURE  dbo.CapaCargaDetalleInstitucion
    (@companyId bigint,
    @IdInstitucion bigint)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
	SELECT [idInstitucion]
		  ,[clave]
		  ,[nombre]
		  ,[direccion]
		  ,[ciudad]
		  ,[estado]
		  ,[telefono]
		  ,[fax]
		  ,[contacto]
		  ,[email]
		  ,[rfc]
		  ,[fechaalta]
		  ,[claveSTPS] 
	FROM capa_Institucion
	WHERE empresa=@companyId
	and idInstitucion=@idinstitucion
    order by nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

       
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaValidaPermisosUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaValidaPermisosUsuario
GO

CREATE PROCEDURE  dbo.capaValidaPermisosUsuario
    (@sistema VARCHAR(2),
     @opcion VARCHAR(2),
     @funcion VARCHAR(2),
     @usuario VARCHAR(30))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    
    SELECT	usuarios.usuario, 
			perfiles.sistema, 
			perfil_usuarios.idPerfil, 
			perfiles.descripcion,
			perfil_funcion.funcion, 
			perfil_funcion.opcion
    FROM	usuarios 
			left join perfil_usuarios on usuarios.usuario=perfil_usuarios.usuario
			left join perfiles on perfil_usuarios.idperfil= perfiles.idperfil
			left join perfil_funcion on perfil_funcion.idperfil=perfiles.idperfil
    WHERE   perfiles.sistema=@sistema
			and perfil_funcion.opcion=@opcion
			and perfil_funcion.Funcion=@funcion
			and usuarios.usuario=@usuario

    END TRY
    
    BEGIN CATCH

    DECLARE @ErrorSeverity udtInteger
    DECLARE @ErrorState udtInteger
    DECLARE @ErrorMessage udtStringSize2048

    SET @ErrorSeverity = ERROR_SEVERITY()
    SET @ErrorState = ERROR_STATE()
    SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
        + CHAR(13) + CHAR(10) + 'Severity: '
        + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
        + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
        + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
        + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
        + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

    RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaEliminaInstitucion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaEliminaInstitucion
GO

CREATE PROCEDURE  dbo.capaEliminaInstitucion
    (@companyId udtInteger,
     @IdInstitucion udtInteger)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    BEGIN TRY    
    	
    	DELETE FROM [capa_Institucion]
		WHERE empresa=@companyId
		and idInstitucion=@IdInstitucion

    END TRY
   
    BEGIN CATCH

    DECLARE @ErrorSeverity udtInteger
    DECLARE @ErrorState udtInteger
    DECLARE @ErrorMessage udtStringSize2048

    SET @ErrorSeverity = ERROR_SEVERITY()
    SET @ErrorState = ERROR_STATE()
    SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
        + CHAR(13) + CHAR(10) + 'Severity: '
        + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
        + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
        + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
        + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
        + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

    RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaInstitucion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaInstitucion
GO

CREATE PROCEDURE  dbo.capaInsertaInstitucion
    (@companyId udtInteger,
	 @idInstitucion udtInteger ,
	 @clave varchar(35),
	 @nombre varchar(250),
	 @direccion varchar(250),
	 @ciudad varchar(50),
	 @estado varchar(50),
	 @telefono varchar(20),
	 @fax varchar(20),
	 @contacto varchar(100),
	 @email varchar(100),
	 @rfc varchar(20),
	 @fechaalta datetime,
	 @claveSTPS varchar(50))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
    if @idInstitucion=0  
		begin  
			INSERT INTO [capa_Institucion]
				   ([empresa]
				   ,[clave]
				   ,[nombre]
				   ,[direccion]
				   ,[ciudad]
				   ,[estado]
				   ,[telefono]
				   ,[fax]
				   ,[contacto]
				   ,[email]
				   ,[rfc]
				   ,[fechaalta]
				   ,[claveSTPS])
			 VALUES
				   (@companyId
				   ,@clave
				   ,@nombre
				   ,@direccion
				   ,@ciudad
				   ,@estado
				   ,@telefono
				   ,@fax
				   ,@fax
				   ,@email
				   ,@rfc
				   ,@fechaalta
				   ,@claveSTPS)
		end				   
	else
		begin
			UPDATE [capa_Institucion]
			   SET [clave] =@clave
				  ,[nombre] = @nombre
				  ,[direccion] = @direccion
				  ,[ciudad] = @ciudad
				  ,[estado] = @estado
				  ,[telefono] = @telefono
				  ,[fax] = @fax
				  ,[contacto] = @contacto	
				  ,[email] = @email
				  ,[rfc] =@rfc
				  ,[fechaalta] = @fechaalta
				  ,[claveSTPS] = @claveSTPS
				 WHERE empresa=@companyId
				 and idInstitucion=@idInstitucion
		end 			   

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTieneInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTieneInstructor
GO

CREATE PROCEDURE  dbo.capaTieneInstructor
    (@companyId udtInteger,
	 @idInstitucion udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT count(*) 
	FROM capa_instructor 
	WHERE empresa= @companyid
	and idInstitucion= @idInstitucion

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaClavesInstituciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaClavesInstituciones
GO

CREATE PROCEDURE  dbo.capaClavesInstituciones
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
		SELECT [idInstitucion]
		  ,[clave]
		  ,[nombre]   
		FROM [capa_Institucion]
		where empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoInstructor
GO

CREATE PROCEDURE  dbo.capaListadoInstructor
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT capa_Instructor.idInstructor
			  ,capa_Instructor.nombre
			  ,capa_Instructor.idCiudad
			  ,capa_Instructor.idEstado
			  ,capa_Instructor.Externo
			  ,capa_Instructor.idInstitucion
			  ,capa_Institucion.nombre 
	FROM capa_Instructor
	inner join capa_Institucion on capa_Instructor.empresa=capa_Institucion.empresa and
				capa_Instructor.idInstitucion=capa_Institucion.idInstitucion
	where capa_Instructor.empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaDetalleInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaDetalleInstructor
GO

CREATE PROCEDURE  dbo.capaDetalleInstructor
    (@companyId udtInteger,
     @idInstructor udtinteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
		SELECT capa_Instructor.idInstructor
			  ,capa_Instructor.nombre
			  ,capa_Instructor.rfc
			  ,capa_Instructor.direccion
			  ,capa_Instructor.idCiudad		  
			  ,capa_Instructor.idEstado
			  ,capa_Instructor.Telefono
			  ,capa_Instructor.Email
			  ,capa_Instructor.FechaRegistro		  
			  ,capa_Instructor.idInstitucion
			  ,rtrim(capa_Institucion.nombre) as institucion
			  ,capa_Instructor.Externo
			  ,capa_Instructor.registroSTPS
			  ,capa_Institucion.fechaalta	
			  ,capa_Instructor.estatus 
			  ,capa_Instructor.imagenFirma
		FROM capa_Instructor
		inner join capa_Institucion 
			on capa_Instructor.empresa=capa_Institucion.empresa and
			capa_Instructor.idInstitucion=capa_Institucion.idInstitucion
		where capa_Instructor.empresa=@companyId
		and capa_Instructor.idInstructor=@idInstructor

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaInstructor
GO

CREATE PROCEDURE  dbo.capaInsertaInstructor
    (	@companyId bigint
	   ,@idInstructor bigint
	   ,@nombre varchar(250)
	   ,@rfc varchar(50)
	   ,@direccion varchar(200)
	   ,@idCiudad varchar(50)
	   ,@idEstado varchar(50)
	   ,@Telefono varchar(50)
	   ,@Email varchar(100)
	   ,@FechaRegistro datetime
	   ,@idInstitucion bigint
	   ,@Externo char(1)
	   ,@registroSTPS varchar(100)
	   ,@fechaalta datetime)
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
    if @idInstitucion=0  
		begin  
			INSERT INTO capa_Instructor
				   (empresa
				   ,nombre
				   ,rfc
				   ,direccion
				   ,idCiudad
				   ,idEstado
				   ,Telefono
				   ,Email
				   ,FechaRegistro
				   ,idInstitucion
				   ,Externo
				   ,registroSTPS
				   ,fechaalta)
			 VALUES
				   (@companyId
				   ,@nombre
				   ,@rfc
				   ,@direccion
				   ,@idCiudad
				   ,@idEstado
				   ,@Telefono
				   ,@Email
				   ,@FechaRegistro
				   ,@idInstitucion
				   ,@Externo
				   ,@registroSTPS
				   ,@fechaalta)
		end				   
	else
		begin
		UPDATE [capa_Instructor]
		   SET [nombre] = @nombre
			  ,[rfc] = @rfc
			  ,[direccion] = @direccion
			  ,[idCiudad] = @idCiudad
			  ,[idEstado] = @idEstado
			  ,[Telefono] = @Telefono
			  ,[Email] = @Email
			  ,[FechaRegistro] = @FechaRegistro
			  ,[idInstitucion] =@idInstitucion
			  ,[Externo] = @Externo
			  ,[registroSTPS] = @registroSTPS
			  ,[fechaalta] = @fechaalta
		 WHERE empresa=@companyId
			and idInstitucion=@idInstructor
		end 			   

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusLugares'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusLugares
GO

CREATE PROCEDURE  dbo.capaListadoBusLugares
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT empresa
		  ,idLugar
		  ,Lugar
	FROM Capa_Lugar
	WHERE empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusCursos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusCursos
GO

CREATE PROCEDURE  dbo.capaListadoBusCursos
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT c.idcurso, c.clave,c.nombre,t.idTipocurso, t.nombre, isnull(a.clave,'')
	FROM capa_curso c
		inner join capa_Tipocurso t on t.empresa=c.empresa and t.idTipocurso=c.idTipocurso 
		left outer join capa_ActividadMedida a on a.IdActividad=c.idActividad and a.empresa=c.empresa
	where c.empresa=@companyId
    order by c.nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusInstructor'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusInstructor
GO

CREATE PROCEDURE  dbo.capaListadoBusInstructor
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT  i.idInstructor, i.nombre, t.idInstitucion, t.clave, t.nombre
	FROM capa_Instructor i inner join capa_Institucion t
		 on i.empresa=t.empresa and i.idInstitucion=t.idInstitucion
	where i.empresa=@companyId
    

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusInstituciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusInstituciones
GO

CREATE PROCEDURE  dbo.capaListadoBusInstituciones
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT idInstitucion
		  ,clave
		  ,nombre
	FROM Capa_Institucion
	WHERE empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusArea'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusArea
GO

CREATE PROCEDURE  dbo.capaListadoBusArea
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT idDenominacion, rtrim(idDenominacion) as clave, clave + ' ' + area as nombre
	FROM capa_CatalogoAreaTematica

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )
        
        
    END CATCH
go



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoBusTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoBusTemario
GO

CREATE PROCEDURE  dbo.capaListadoBusTemario
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
	SELECT idTemario, idTemario, nombre
	FROM capa_temario
	where empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )        
        
    END CATCH
go
 

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoTipoCurso'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoTipoCurso
GO

CREATE PROCEDURE  dbo.capaListadoTipoCurso
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
		SELECT	idtipocurso,
				idtipocurso, 
				nombre 
		from capa_TipoCurso 
		where empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaEliminaTipoCurso'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaEliminaTipoCurso
GO

CREATE PROCEDURE  dbo.capaEliminaTipoCurso
    (@companyId udtInteger,
     @IdTipoCurso varchar(100),
     @nombre varchar(100) )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
		DELETE FROM capa_TipoCurso
		WHERE empresa=@companyId
		AND idtipocurso=@IdTipoCurso
		AND NOMBRE=@nombre

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

 if  exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.ID = T.ID 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_programacion' 
                 and c.name='idLugar')
  ALTER TABLE capa_programacion alter column idLugar varchar(25) null
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaProgramacion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaProgramacion
GO

CREATE PROCEDURE  dbo.capaInsertaProgramacion
    (	@companyId udtInteger,
        @idProgramacion udtInteger,
        @idCurso udtInteger,
		@idLugar varchar(25),
		@idInstructor bigint,
		@finicial datetime,
		@ffinal datetime,
		@horaini1 varchar(10),
		@horafin1 varchar(10),
		@horaini2 varchar(10),
		@horafin2 varchar(10),
		@tothoras varchar(10),
		@costoPersona varchar(10),
		@capacidad varchar(10),
		@stps varchar(1),
		@modalidad varchar(5),
		@objetivo varchar(5),
		@norma varchar(50),
		@fechaReprogramado datetime,
		@MotivoReprogramado varchar(300))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    if @idProgramacion=0
    begin 
		INSERT INTO capa_programacion
			   (empresa
			   ,idcurso
			   ,idLugar
			   ,idInstructor
			   ,finicial
			   ,ffinal
			   ,horaini1
			   ,horafin1
			   ,horaini2
			   ,horafin2
			   ,tothoras
			   ,costoPersona
			   ,capacidad
			   ,stps
			   ,modalidad
			   ,objetivo
			   ,norma
			   ,numeroConsecutivo
			   ,fechaReprogramado
			   ,motivoReprogramado)
		 VALUES
			   (@companyId,
			    @idCurso,
				@idLugar,
				@idInstructor,
				@finicial ,
				@ffinal ,
				@horaini1,
				@horafin1,
				@horaini2,
				@horafin2,
				@tothoras,
				@costoPersona,
				@capacidad,
				@stps,
				@modalidad,
				@objetivo,
				@norma,
				0,
				@fechaReprogramado,
				@MotivoReprogramado)
		end
	else
		begin
			UPDATE capa_programacion
		    SET 
			  idcurso = @idCurso
			  ,idLugar = @idLugar
			  ,idInstructor = @idInstructor
			  ,finicial = @finicial
			  ,ffinal = @ffinal
			  ,horaini1 = @horaini1
			  ,horafin1 = @horafin1
			  ,horaini2 = @horaini2
			  ,horafin2 = @horafin2
			  ,tothoras = @tothoras
			  ,costoPersona = @costoPersona
			  ,capacidad = @capacidad
			  ,stps = @stps
			  ,modalidad = @modalidad
			  ,objetivo = @objetivo
			  ,norma = @norma
			  ,fechaReprogramado=@fechaReprogramado
			  ,motivoReprogramado=@MotivoReprogramado
			WHERE empresa = @companyid
			and	  idprogramacion= @idProgramacion
		end

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity	= ERROR_SEVERITY()
        SET @ErrorState		= ERROR_STATE()
        SET @ErrorMessage	= 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
							+ CHAR(13) + CHAR(10) + 'Severity: '
							+ LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
							+ 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
							+ CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
							+ 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
							+ 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaReprogramacion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaReprogramacion
GO

CREATE PROCEDURE  dbo.capaInsertaReprogramacion
    (	@idEmpresa bigint,
        @idProgramacion bigint,
		@fechaReprogramado datetime,
		@MotivoReprogramado varchar(300))
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY

	declare @idProgramacionNueva as bigint
	declare @idCurso as bigint
	declare	@idLugar as varchar(25)
	declare	@idInstructor as bigint
	declare	@finicial as datetime
	declare	@ffinal as datetime
	declare	@horaini1 as varchar(10)
	declare	@horafin1 as varchar(10)
	declare	@horaini2 as varchar(10)
	declare	@horafin2 as varchar(10)
	declare	@tothoras as varchar(10)
	declare	@costoPersona as varchar(10)
	declare	@capacidad as varchar(10)
	declare	@stps as varchar(1)
	declare	@modalidad as varchar(5)
	declare	@objetivo as varchar(5)
	declare	@norma as varchar(50)

	update capa_programacion
	set fechaReprogramado=@fechaReprogramado,
		MotivoReprogramado=@MotivoReprogramado
	where empresa=@idEmpresa
	and idprogramacion=@idProgramacion 

	select  @idCurso = idcurso,
			@idLugar = idLugar,
			@idInstructor = idInstructor,
			@finicial = finicial,
			@ffinal = ffinal,
			@horaini1 = horaini1,
			@horafin1 = horafin1,
			@horaini2 = horaini2,
			@horafin2 = horafin2,
			@tothoras = tothoras,
			@costoPersona = costoPersona,
			@capacidad = capacidad,
			@stps = stps,
			@modalidad = modalidad,
			@objetivo = objetivo,
			@norma = norma
	from capa_programacion 
	where empresa=@idEmpresa
	and idprogramacion=@idProgramacion

	INSERT INTO capa_programacion
			   (empresa
			   ,idcurso
			   ,idLugar
			   ,idInstructor
			   ,finicial
			   ,ffinal
			   ,horaini1
			   ,horafin1
			   ,horaini2
			   ,horafin2
			   ,tothoras
			   ,costoPersona
			   ,capacidad
			   ,stps
			   ,modalidad
			   ,objetivo
			   ,norma
			   ,numeroConsecutivo
			   ,fechaReprogramado
			   ,motivoReprogramado)
		select @idempresa,
				@idCurso,
				@idLugar,
				@idInstructor,
				@fechaReprogramado ,
				@fechaReprogramado ,
				@horaini1,
				@horafin1,
				@horaini2,
				@horafin2,
				@tothoras,
				@costoPersona,
				@capacidad,
				@stps,
				@modalidad,
				@objetivo,
				@norma,
				0,
				'19000101',
				''
				from capa_programacion 
				where empresa=@idEmpresa
				and idprogramacion=@idProgramacion

	select @idprogramacionNueva=isnull(idprogramacion,0)
	from capa_programacion
	where  idcurso = @idCurso
			and idLugar = @idLugar
			and idInstructor = @idInstructor
			and finicial = @fechaReprogramado
			and ffinal = @fechaReprogramado
			and horaini1 = @horaini1
			and horafin1 = @horafin1
			and horaini2 = @horaini2
			and horafin2 = @horafin2
			and tothoras = @tothoras
			and costoPersona = @costoPersona
			and capacidad = @capacidad
			and stps = @stps
			and modalidad = @modalidad
			and objetivo = @objetivo
			and norma = @norma
			and MotivoReprogramado=''

	if @idProgramacionNueva>0
		begin
			update capa_programacion
			set idProgramacionNueva=@idProgramacionNueva
			where empresa=@idEmpresa
			and idprogramacion=@idProgramacion

			insert into capa_EmpleadoProgramacion (empresa, codigo, idprogramacion, calificacion ,asistencia ,comentarios)
			select empresa, codigo, @idProgramacionNueva, 0 ,'No' ,''
			from capa_Empleadoprogramacion
			where empresa=@idEmpresa
			and idprogramacion=@idProgramacion
		end	
    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity	= ERROR_SEVERITY()
        SET @ErrorState		= ERROR_STATE()
        SET @ErrorMessage	= 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
							+ CHAR(13) + CHAR(10) + 'Severity: '
							+ LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
							+ 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
							+ CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
							+ 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
							+ 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaListadoPuestosNominaConsulta'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaListadoPuestosNominaConsulta
GO

CREATE PROCEDURE  dbo.capaListadoPuestosNominaConsulta
    (@companyId udtInteger )
   
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    SET XACT_ABORT ON
    
    BEGIN TRY
    
		select ocupacion,ocupacion, actividad
		from tabulador
		WHERE empresa=@companyId

    END TRY
    
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.capaEvaluacionPreguntasMobile')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.capaEvaluacionPreguntasMobile
GO

CREATE PROCEDURE dbo.capaEvaluacionPreguntasMobile
	(	
		@companyId bigint
	) 
	
AS 
	SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
BEGIN
	
	select c.idPregunta, t.tipo, c.texto
	from capa_EvalPregunta c, capa_evaltipopregunta t
	where c.empresa=@companyId
	and c.empresa=t.empresa
	and c.idtipo=t.idtipo
	ORDER BY t.idtipo,c.ORDEN

end
go

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.capaEvaluacionCalificacionesMobile')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.capaEvaluacionCalificacionesMobile
GO

CREATE PROCEDURE dbo.capaEvaluacionCalificacionesMobile
	(	
		@companyId bigint
	) 
	
AS 
	SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
BEGIN
	
	Select idCalificacion,nombre 
	from capa_EvalCalificacion 
	where empresa=@companyId
	order by orden
	
end
/************************************************************/

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_curso' 
                 and c.name='claveSTPS')
  ALTER TABLE capa_Curso ADD claveSTPS varchar(25) NULL
go

