if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_curso' 
                 and c.name='MatrizHabilidades')
  ALTER TABLE  capa_curso ADD MatrizHabilidades VARCHAR(1) NULL
go

update capa_curso set MatrizHabilidades='N' where MatrizHabilidades is null
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capaMatriz_Operacion' 
                 and c.name='idCurso')
  ALTER TABLE  capaMatriz_Operacion ADD idCurso bigint NULL
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_curso' 
                 and c.name='claveSTPS')
  ALTER TABLE capa_Curso ADD claveSTPS varchar(25) NULL
go

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_curso' 
                 and c.name='ordenEnTipoCurso')
  ALTER TABLE  capa_curso ADD ordenEnTipoCurso int NULL
GO

update capa_curso set ordenEnTipoCurso=0 where ordenEnTipoCurso is null
GO

 if not exists (SELECT distinct(c.name)
                  FROM dbo.SYSCOLUMNS C
                  INNER JOIN dbo.SYSOBJECTS T 
                  ON C.[ID] = T.[ID] 
                  WHERE T.XTYPE = 'U' 
                  and t.name='capa_curso' 
                 and c.name='idTemarioInterno')
  ALTER TABLE  capa_curso ADD idTemarioInterno bigint NULL
GO

update capa_curso set idTemarioInterno=0 where idTemarioInterno is null
GO

/*******************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaInsertaCursoCatalogo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaInsertaCursoCatalogo
GO

CREATE PROCEDURE  dbo.capaInsertaCursoCatalogo
    (	@idEmpresa  as numeric(3,0)
		,@idcurso as bigint
		,@clave as varchar(50)
		,@nombre as varchar(400)
		,@tothoras as  decimal(5,2)
		,@costo_persona as decimal(12,2)
		,@estatus as varchar(50)
		,@capacidad as numeric(18,0)
		,@idtemario as bigint
		,@idTipocurso as varchar(10)
		,@stps as varchar(1)
		,@automatico as char(1)
		,@idDenominacion as bigint
		,@numeroConsecutivo as bigint
		,@puntos as bigint
		,@objetivo as varchar(250)
		,@idActividad as bigint
		,@MatrizHabilidades as varchar(1)
		,@ClaveSTPS as varchar(25)		
		,@idTemarioInterno as bigint
		,@ordenEnTipoCurso as int
		)
	
AS 

    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    if @idcurso=0
		begin
			INSERT INTO Capa_curso
           (empresa
           ,clave
           ,nombre
           ,tothoras
           ,costo_persona
           ,estatus
           ,capacidad
           ,idtemario
           ,idTipocurso
           ,stps
           ,automatico
           ,fechaalta
           ,idDenominacion
           ,numeroConsecutivo
           ,puntos
           ,objetivo
           ,idActividad
           ,MatrizHabilidades
           ,claveSTPS
		   ,ordenEnTipoCurso
		   ,idTemarioInterno)
     VALUES
			(@idEmpresa
			,@clave 
			,@nombre 
			,@tothoras 
			,@costo_persona
			,@estatus 
			,@capacidad 
			,@idtemario
			,@idTipocurso 
			,@stps 
			,@automatico
			,GETDATE()
			,@idDenominacion
			,@numeroConsecutivo
			,@puntos
			,@objetivo
			,@idActividad
			,@MatrizHabilidades
			,@ClaveSTPS
			,@ordenEnTipoCurso
			,@idTemarioInterno)
		end		
	else
		begin
			UPDATE Capa_curso
			SET empresa = @idEmpresa
			,clave = @clave
			  ,nombre = @nombre
			  ,tothoras = @tothoras
			  ,costo_persona = @costo_persona
			  ,estatus = @estatus
			  ,capacidad = @capacidad
			  ,idtemario = @idtemario
			  ,idTipocurso = @idTipocurso
			  ,stps = @stps
			  ,automatico = @automatico
			  ,idDenominacion = @idDenominacion
			  ,numeroConsecutivo = @numeroConsecutivo
			  ,puntos = @puntos
			  ,objetivo = @objetivo
			  ,idActividad = @idActividad
			  ,MatrizHabilidades = @MatrizHabilidades
			  ,clavestps=@clavestps
			  ,ordenEnTipoCurso=@ordenEnTipoCurso
			  ,idTemarioInterno=@idTemarioInterno
			WHERE idcurso=	@idcurso
		end	
GO

/***************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaObtenDetalleDeCurso'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaObtenDetalleDeCurso
GO

CREATE Procedure dbo.CapaObtenDetalleDeCurso
	(			
		@idCompany bigint,
		@idcurso bigint
	) 

AS 
    BEGIN
    
    SELECT Capa_curso.empresa
          ,Capa_curso.idcurso
		  ,Capa_curso.clave
		  ,Capa_curso.nombre
		  ,Capa_curso.tothoras
		  ,Capa_curso.costo_persona
		  ,Capa_curso.estatus
		  ,Capa_curso.capacidad
		  ,Capa_curso.idtemario as idtemario
		  ,capa_temario.nombre as temario
		  ,capa_Tipocurso.idTipocurso
		  ,capa_Tipocurso.nombre as tipocurso
		  ,Capa_curso.stps
		  ,Capa_curso.fechaalta
		  ,Capa_curso.automatico
		  ,isnull(capa_CatalogoAreaTematica.idDenominacion,1) as idAreaTematica
		  ,rtrim(capa_CatalogoAreaTematica.clave) + ' ' + rtrim(capa_CatalogoAreaTematica.area) as AreaTematica
		  ,Capa_curso.numeroConsecutivo
		  ,Capa_curso.puntos
		  ,Capa_curso.objetivo
		  ,isnull(capa_curso.idActividad,0) as idActividad
		  ,isnull(capa_curso.matrizHabilidades,'N')
		  ,claveSTPS
		  ,capa_TemarioInterno.idTemarioInterno as idTemarioInterno
		  ,capa_TemarioInterno.clave as claveTemarioInterno
		  ,capa_TemarioInterno.nombre as nombreTemarioInterno
		  ,ordenEnTipoCurso
	  FROM Capa_curso
	  LEFT join capa_Tipocurso on Capa_curso.idTipocurso =capa_Tipocurso.idTipocurso 
			 and Capa_curso.empresa=capa_Tipocurso.empresa	
	  LEFT join capa_temario on Capa_curso.idtemario = capa_temario.idtemario 
			 and Capa_curso.empresa=capa_temario.empresa		 
	  LEFT join capa_CatalogoAreaTematica on Capa_curso.idDenominacion =capa_CatalogoAreaTematica.idDenominacion	 			 
	  LEFT join capa_temariointerno on Capa_curso.idtemariointerno =capa_temariointerno.idTemarioInterno and
									Capa_curso.empresa=capa_temariointerno.empresa	
	  where Capa_curso.empresa=@idCompany
			 and  Capa_curso.idcurso=@idcurso
	
	end
                                        
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaObtenDetalleDeCursoConTemario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaObtenDetalleDeCursoConTemario
GO

CREATE Procedure dbo.CapaObtenDetalleDeCursoConTemario
	(			
		@idCompany bigint,
		@idcurso bigint
	) 

AS 
    BEGIN
    
    SELECT Capa_curso.empresa
          ,Capa_curso.idcurso
		  ,Capa_curso.clave
		  ,Capa_curso.nombre
		  ,Capa_curso.tothoras
		  ,Capa_curso.costo_persona
		  ,Capa_curso.estatus
		  ,Capa_curso.capacidad
		  ,Capa_curso.idtemario as idtemario
		  ,capa_temario.nombre as temario
		  ,capa_Tipocurso.idTipocurso
		  ,capa_Tipocurso.nombre as tipocurso
		  ,Capa_curso.stps
		  ,Capa_curso.fechaalta
		  ,Capa_curso.automatico
		  ,isnull(capa_CatalogoAreaTematica.idDenominacion,1) as idAreaTematica
		  ,rtrim(capa_CatalogoAreaTematica.clave) + ' ' + rtrim(capa_CatalogoAreaTematica.area) as AreaTematica
		  ,Capa_curso.numeroConsecutivo
		  ,Capa_curso.puntos
		  ,Capa_curso.objetivo
		  ,isnull(capa_curso.idActividad,0) as idActividad
		  ,isnull(capa_curso.matrizHabilidades,'N')
		  ,claveSTPS
		  ,capa_TemarioInterno.idTemarioInterno as idTemarioInterno
		  ,capa_TemarioInterno.clave as claveTemarioInterno
		  ,capa_TemarioInterno.nombre as nombreTemarioInterno
		  ,ordenEnTipoCurso
		  ,capa_Tema.clave as claveTemario
		  ,capa_Tema.nombre as nombreTemario
		  ,capa_Tema.duracion 
	  FROM Capa_curso
	  LEFT join capa_Tipocurso on Capa_curso.idTipocurso =capa_Tipocurso.idTipocurso 
			 and Capa_curso.empresa=capa_Tipocurso.empresa	
	  LEFT join capa_temario on Capa_curso.idtemario = capa_temario.idtemario 
			 and Capa_curso.empresa=capa_temario.empresa		 
	  LEFT join capa_CatalogoAreaTematica on Capa_curso.idDenominacion =capa_CatalogoAreaTematica.idDenominacion	 			 
	  LEFT join capa_temariointerno on Capa_curso.idtemariointerno =capa_temariointerno.idTemarioInterno and
									Capa_curso.empresa=capa_temariointerno.empresa	
	  LEFT join capa_tema on Capa_curso.idtemariointerno = capa_tema.idTemarioInterno and
									Capa_curso.empresa = capa_tema.empresa	
	  where Capa_curso.empresa=@idCompany
			 and  Capa_curso.idcurso=@idcurso
	 ORDER BY CAPA_CURSO.idcurso, capa_Tema.orden
	
	end
                                        
GO




/********************************** TEMARIO INTERNO  *********************************/


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemarioInternoInserta'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemarioInternoInserta
GO

CREATE PROCEDURE  dbo.capaTemarioInternoInserta
	(@Empresa  as bigint
	,@idTemarioInterno as bigint
	,@clave as varchar(15)
	,@nombre as varchar(250)
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    if @idTemarioInterno=0
		begin
			INSERT INTO capa_TemarioInterno
           (empresa
		   ,idTemarioInterno
           ,clave
           ,nombre     )
		   VALUES
			(@Empresa
			,(select isnull(max(idtemariointerno),0)+1 from capa_TemarioInterno where empresa=@Empresa)
			,@clave 
			,@nombre )
		end		
	else
		begin
			UPDATE capa_TemarioInterno
			SET empresa = @Empresa
			,clave = @clave
			  ,nombre = @nombre			 
			WHERE idTemarioInterno = @idTemarioInterno
			and empresa=@Empresa
		end	
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemarioInternoListado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemarioInternoListado
GO

CREATE PROCEDURE  dbo.capaTemarioInternoListado
	(@Empresa  as bigint
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
        
	SELECT idTemarioInterno
		  ,clave
		  ,nombre
	  FROM capa_TemarioInterno
	  where empresa=@Empresa
	  order by clave
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemarioInternoElimina'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemarioInternoElimina
GO

CREATE PROCEDURE  dbo.capaTemarioInternoElimina
	(@Empresa  as bigint,
	 @idTemariointerno as bigint
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
        
	delete from capa_TemarioInterno
	where empresa=@Empresa
	and idTemarioInterno=@idTemariointerno


GO
/*****************************   TEMAS    **********************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemaInserta'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemaInserta
GO

CREATE PROCEDURE  dbo.capaTemaInserta
	(@Empresa  as bigint
    ,@idTema as bigint
    ,@idTemarioInterno as bigint
    ,@clave as varchar(15)
    ,@nombre as varchar(250)
    ,@duracion as decimal(5,2)
    ,@idInstructor as bigint
    ,@orden as int
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    if @idTema=0
		begin

		INSERT INTO capa_Tema
           ([empresa]
           ,[idTema]
           ,[idTemarioInterno]
           ,[clave]
           ,[nombre]
           ,[duracion]
           ,[idInstructor]
           ,[orden])
     VALUES
           (@empresa
           ,(select isnull(max(idtema),0)+1 from capa_Tema where empresa=@Empresa)
           ,@idTemarioInterno
           ,@clave
           ,@nombre
           ,@duracion
           ,@idInstructor
           ,@orden)
		end		
	else
		begin
			UPDATE capa_Tema
			   SET empresa = @empresa
				  ,idTema  = @idTema
				  ,idTemarioInterno = @idTemarioInterno
				  ,clave	= @clave
				  ,nombre	= @nombre
				  ,duracion = @duracion
				  ,idInstructor = @idInstructor
				  ,orden	= @orden 
			WHERE idTema	= @idTema
			and idtemariointerno=@idTemarioInterno
			and empresa=@Empresa
		end	
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemaListado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemaListado
GO

CREATE PROCEDURE  dbo.capaTemaListado
	(@Empresa  as bigint,
	 @idTemarioInterno as bigint
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
        
	SELECT t.idTema
		  ,t.idTemarioInterno
		  ,t.clave
		  ,t.nombre
		  ,t.duracion
		  ,t.idInstructor
		  ,capa_instructor.nombre as nombreInstructor
		  ,t.orden
	  FROM capa_Tema t
	  left join capa_Instructor on t.empresa=capa_Instructor.empresa and
									t.idInstructor=capa_Instructor.idInstructor
	  where t.empresa=@Empresa
	  and idTemarioInterno=@idtemariointerno
	  order by t.clave
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemaElimina'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemaElimina
GO

CREATE PROCEDURE  dbo.capaTemaElimina
	(@Empresa  as bigint,
	 @idTemariointerno as bigint,
	 @idTema as bigint
	)
	
AS 
BEGIN
    SET NOCOUNT ON
    SET DATEFORMAT MDY   

	delete from capa_Tema
	where empresa=@Empresa
			and idTemarioInterno=@idTemariointerno
			and idTema=@idtema
END
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'capaTemaReporte'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.capaTemaReporte
GO

CREATE PROCEDURE  dbo.capaTemaReporte
	(@Empresa  as bigint,
	 @idTemarioInterno as bigint
	)
	
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
        
	SELECT t.idTema
		  ,t.idTemarioInterno
		  ,capa_TemarioInterno.nombre as nombreTemario
		  ,t.clave
		  ,t.nombre
		  ,t.duracion
		  ,t.idInstructor
		  ,capa_instructor.nombre as nombreInstructor
		  ,t.orden
	  FROM capa_Tema t
	  left join capa_Instructor on t.empresa=capa_Instructor.empresa and
									t.idInstructor=capa_Instructor.idInstructor
	  left join capa_TemarioInterno on t.empresa=capa_TemarioInterno.empresa and
									t.idTemarioInterno=capa_TemarioInterno.idTemarioInterno
	  where t.empresa=@Empresa
	  and iif(@idtemariointerno=0,0,t.idtemariointerno)=iif(@idtemariointerno=0,0,@idtemariointerno)
	  order by t.idTemarioInterno, t.orden
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CapaObtenTemariosPorTipo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CapaObtenTemariosPorTipo
GO

CREATE Procedure dbo.CapaObtenTemariosPorTipo
	(			
		@empresa bigint,
		@TipoCurso varchar(15)
	) 

AS 
    BEGIN
    
    SELECT   capa_Tipocurso.idTipocurso
		    ,capa_Tipocurso.nombre as tipocurso
			,Capa_curso.empresa
			,Capa_curso.idcurso
			,Capa_curso.clave
			,Capa_curso.nombre
			,Capa_curso.tothoras
			,Capa_curso.costo_persona
			,Capa_curso.estatus
			,Capa_curso.capacidad
			,Capa_curso.idtemario as idtemario
			,capa_temario.nombre as temario		
			,isnull(capa_CatalogoAreaTematica.idDenominacion,1) as idAreaTematica
			,rtrim(capa_CatalogoAreaTematica.clave) + ' ' + rtrim(capa_CatalogoAreaTematica.area) as AreaTematica
			,Capa_curso.numeroConsecutivo
			,Capa_curso.objetivo
			,isnull(capa_curso.idActividad,0) as idActividad
			,claveSTPS
			,capa_TemarioInterno.idTemarioInterno as idTemarioInterno
			,capa_TemarioInterno.clave as claveTemarioInterno
			,capa_TemarioInterno.nombre as nombreTemarioInterno
			,ordenEnTipoCurso
			,capa_Tema.clave as claveTemario
			,capa_Tema.nombre as nombreTemario
			,capa_Tema.duracion 
	  FROM capa_Tipocurso
	  inner join Capa_curso on Capa_curso.idTipocurso =capa_Tipocurso.idTipocurso 
			 and Capa_curso.empresa=capa_Tipocurso.empresa	
	  inner join capa_temario on Capa_curso.idtemario = capa_temario.idtemario 
			 and Capa_curso.empresa=capa_temario.empresa		 
	  inner join capa_CatalogoAreaTematica on Capa_curso.idDenominacion =capa_CatalogoAreaTematica.idDenominacion	 			 
	  inner join capa_temariointerno on Capa_curso.idtemariointerno =capa_temariointerno.idTemarioInterno and
									Capa_curso.empresa=capa_temariointerno.empresa	
	  inner join capa_tema on Capa_curso.idtemariointerno = capa_tema.idTemarioInterno and
									Capa_curso.empresa = capa_tema.empresa	
	  where Capa_curso.empresa=@empresa
			 and  iif(@TipoCurso='0','0',capa_Tipocurso.idtipocurso)=iif(@TipoCurso='0','0',@TipoCurso)
	 ORDER BY capa_curso.idtipocurso, capa_temario.idtemario, capa_Tema.orden
	
	end
                                        
GO