

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaProgramacionMultiple'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaProgramacionMultiple
GO

CREATE Procedure dbo.insertaProgramacionMultiple
	(			
		@idempresa bigint,
		@idprogramacion bigint,
		@fechaInicio datetime
	) 

AS 
    BEGIN
    
    declare @dias as int
    
    select @dias=DATEDIFF(DD,fInicial,ffinal)
    from capa_programacion 
    where idprogramacion=@idprogramacion 
    and empresa=@idempresa
    
    IF OBJECT_ID('tempdb..#tmpProgramacion') IS NOT NULL
    DROP TABLE #tmpProgramacion
    
    create table #tmpProgramacion (empresa numeric(3,0)
							,idprogramacion bigint
							,idcurso bigint
							,idLugar varchar(25)
							,idInstructor bigint
							,finicial datetime
							,ffinal datetime
							,horaini1 varchar(10)
							,horafin1 varchar(10)
							,horaini2 varchar(10)
							,horafin2 varchar(10)
							,tothoras varchar(10)
							,costoPersona varchar(10)
							,capacidad varchar(10)
							,stps varchar(1)
							,modalidad varchar(5)
							,objetivo varchar(5)
							,norma varchar(50)
							,numeroConsecutivo bigint)

	insert into #tmpProgramacion 						
	 select empresa,
			idprogramacion,
			idcurso,
			idLugar,
			idInstructor,
			finicial,
			ffinal,
			horaini1,
			horaini2,
			horafin1,
			horafin2,
			tothoras,
			costoPersona,
			capacidad,
			stps,
			modalidad,
			objetivo,
			norma,
			numeroConsecutivo			
	 from capa_programacion where idprogramacion=@idprogramacion and empresa=@idempresa
		
	insert into capa_programacion
		select empresa
			  ,idcurso
			  ,idLugar
			  ,idInstructor
			  ,@fechaInicio
			  ,dateadd(dd,@dias,@fechaInicio)
			  ,horaini1
			  ,horafin1
			  ,horaini2
			  ,horafin2
			  ,tothoras
			  ,costoPersona
			  ,capacidad
			  ,stps
			  ,modalidad
			  ,objetivo
			  ,norma
			  ,numeroConsecutivo
			  ,'19000101'
			  ,''
			  ,null
		from #tmpProgramacion		
		where idprogramacion=@idprogramacion 
		and empresa=@idempresa 
	
end
                                        
GO

/**************************************************************************************************
 * Name          : capaObtenMaximoNivelEstudios
 * Project       : APSI Portal
 * Description   : Obtiene lista de consuta rapida de trabajadores
 * Table name    : capa_empleadoProgramacion, capa_programacion, capa_temario, capa_curso, empleados
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Margarita Valdez (margarita@apsi.com.mx)
 * Creation date : jueves, Junio 7, 2012
 **************************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalEmpleadoGuardaLogo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalEmpleadoGuardaLogo
GO

CREATE PROCEDURE  dbo.PortalEmpleadoGuardaLogo
    (@idEmpresa as bigint,
     @rutaLogo as varchar(max))
AS 
	
	if exists(Select idempresa from PortalEmpleadoLogo where idempresa=@idempresa)
		update PortalEmpleadoLogo set rutaImagen=@rutaLogo
		where idempresa=@idempresa
	else
		insert into PortalEmpleadoLogo values (@idempresa,@rutaLogo)

go


